import{S as ng,i as dg,s as lg,e as o,k as m,w as b,t as c,M as ig,c as r,d as a,m as g,a as d,x as v,h as p,b as y,G as e,g as $,y as w,q as x,o as D,B as E,v as cg,L as S}from"../../chunks/vendor-hf-doc-builder.js";import{D as j}from"../../chunks/Docstring-hf-doc-builder.js";import{C as I}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as wr}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as T}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function pg(k){let l,_,f,n,u;return n=new I({props:{code:`from datasets import load_dataset_builder
builder = load_dataset_builder('rotten_tomatoes')
ds = builder.download_and_prepare()
ds = builder.as_dataset(split='train')
ds`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset_builder
<span class="hljs-meta">&gt;&gt;&gt; </span>builder = load_dataset_builder(<span class="hljs-string">&#x27;rotten_tomatoes&#x27;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = builder.download_and_prepare()
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = builder.as_dataset(split=<span class="hljs-string">&#x27;train&#x27;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds
Dataset({
    features: [<span class="hljs-string">&#x27;text&#x27;</span>, <span class="hljs-string">&#x27;label&#x27;</span>],
    num_rows: <span class="hljs-number">8530</span>
})`}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function mg(k){let l,_,f,n,u,t,i,de;return i=new I({props:{code:`from datasets import load_dataset_builder
builder = load_dataset_builder("rotten_tomatoes")
ds = builder.download_and_prepare()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset_builder
<span class="hljs-meta">&gt;&gt;&gt; </span>builder = load_dataset_builder(<span class="hljs-string">&quot;rotten_tomatoes&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = builder.download_and_prepare()`}}),{c(){l=o("p"),_=c("Download and prepare the dataset as Arrow files that can be loaded as a Dataset using "),f=o("code"),n=c("builder.as_dataset()"),u=c(":"),t=m(),b(i.$$.fragment)},l(R){l=r(R,"P",{});var H=d(l);_=p(H,"Download and prepare the dataset as Arrow files that can be loaded as a Dataset using "),f=r(H,"CODE",{});var K=d(f);n=p(K,"builder.as_dataset()"),K.forEach(a),u=p(H,":"),H.forEach(a),t=g(R),v(i.$$.fragment,R)},m(R,H){$(R,l,H),e(l,_),e(l,f),e(f,n),e(l,u),$(R,t,H),w(i,R,H),de=!0},p:S,i(R){de||(x(i.$$.fragment,R),de=!0)},o(R){D(i.$$.fragment,R),de=!1},d(R){R&&a(l),R&&a(t),E(i,R)}}}function gg(k){let l,_,f,n,u;return n=new I({props:{code:`from datasets import load_dataset_builder
builder = load_dataset_builder("rotten_tomatoes")
ds = builder.download_and_prepare("./output_dir", file_format="parquet")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset_builder
<span class="hljs-meta">&gt;&gt;&gt; </span>builder = load_dataset_builder(<span class="hljs-string">&quot;rotten_tomatoes&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = builder.download_and_prepare(<span class="hljs-string">&quot;./output_dir&quot;</span>, file_format=<span class="hljs-string">&quot;parquet&quot;</span>)`}}),{c(){l=o("p"),_=c("Download and prepare the dataset as sharded Parquet files locally:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Download and prepare the dataset as sharded Parquet files locally:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function fg(k){let l,_,f,n,u;return n=new I({props:{code:`from datasets import load_dataset_builder
storage_options = {"key": aws_access_key_id, "secret": aws_secret_access_key}
builder = load_dataset_builder("rotten_tomatoes")
ds = builder.download_and_prepare("s3://my-bucket/my_rotten_tomatoes", storage_options=storage_options, file_format="parquet")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset_builder
<span class="hljs-meta">&gt;&gt;&gt; </span>storage_options = {<span class="hljs-string">&quot;key&quot;</span>: aws_access_key_id, <span class="hljs-string">&quot;secret&quot;</span>: aws_secret_access_key}
<span class="hljs-meta">&gt;&gt;&gt; </span>builder = load_dataset_builder(<span class="hljs-string">&quot;rotten_tomatoes&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = builder.download_and_prepare(<span class="hljs-string">&quot;s3://my-bucket/my_rotten_tomatoes&quot;</span>, storage_options=storage_options, file_format=<span class="hljs-string">&quot;parquet&quot;</span>)`}}),{c(){l=o("p"),_=c("Download and prepare the dataset as sharded Parquet files in a cloud storage:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Download and prepare the dataset as sharded Parquet files in a cloud storage:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function ug(k){let l,_,f,n,u;return n=new I({props:{code:`from datasets import load_dataset_builder
ds_builder = load_dataset_builder('rotten_tomatoes')
ds_builder.get_all_exported_dataset_infos()
`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset_builder
<span class="hljs-meta">&gt;&gt;&gt; </span>ds_builder = load_dataset_builder(<span class="hljs-string">&#x27;rotten_tomatoes&#x27;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds_builder.get_all_exported_dataset_infos()
{<span class="hljs-string">&#x27;default&#x27;</span>: DatasetInfo(description=<span class="hljs-string">&quot;Movie Review Dataset.
a dataset of containing 5,331 positive and 5,331 negative processed
s from Rotten Tomatoes movie reviews. This data was first used in Bo
 Lillian Lee, \`\`Seeing stars: Exploiting class relationships for
t categorization with respect to rating scales.&#x27;&#x27;, Proceedings of the
5.
ion=&#x27;@InProceedings{Pang+Lee:05a,
 =       {Bo Pang and Lillian Lee},
=        {Seeing stars: Exploiting class relationships for sentiment
          categorization with respect to rating scales},
tle =    {Proceedings of the ACL},
         2005

age=&#x27;http://www.cs.cornell.edu/people/pabo/movie-review-data/&#x27;, license=&#x27;&#x27;, features={&#x27;text&#x27;: Value(dtype=&#x27;string&#x27;, id=None), &#x27;label&#x27;: ClassLabel(num_classes=2, names=[&#x27;neg&#x27;, &#x27;pos&#x27;], id=None)}, post_processed=None, supervised_keys=SupervisedKeysData(input=&#x27;&#x27;, output=&#x27;&#x27;), task_templates=[TextClassification(task=&#x27;text-classification&#x27;, text_column=&#x27;text&#x27;, label_column=&#x27;label&#x27;)], builder_name=&#x27;rotten_tomatoes_movie_review&#x27;, config_name=&#x27;default&#x27;, version=1.0.0, splits={&#x27;train&#x27;: SplitInfo(name=&#x27;train&#x27;, num_bytes=1074810, num_examples=8530, dataset_name=&#x27;rotten_tomatoes_movie_review&#x27;), &#x27;validation&#x27;: SplitInfo(name=&#x27;validation&#x27;, num_bytes=134679, num_examples=1066, dataset_name=&#x27;rotten_tomatoes_movie_review&#x27;), &#x27;test&#x27;: SplitInfo(name=&#x27;test&#x27;, num_bytes=135972, num_examples=1066, dataset_name=&#x27;rotten_tomatoes_movie_review&#x27;)}, download_checksums={&#x27;https://storage.googleapis.com/seldon-datasets/sentence_polarity_v1/rt-polaritydata.tar.gz&#x27;: {&#x27;num_bytes&#x27;: 487770, &#x27;checksum&#x27;: &#x27;a05befe52aafda71d458d188a1c54506a998b1308613ba76bbda2e5029409ce9&#x27;}}, download_size=487770, post_processing_size=None, dataset_size=1345461, size_in_bytes=1833231)}</span>`}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function _g(k){let l,_,f,n,u;return n=new I({props:{code:`from datasets import load_dataset_builder
ds_builder = load_dataset_builder('rotten_tomatoes')
ds_builder.get_exported_dataset_info()
`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset_builder
<span class="hljs-meta">&gt;&gt;&gt; </span>ds_builder = load_dataset_builder(<span class="hljs-string">&#x27;rotten_tomatoes&#x27;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds_builder.get_exported_dataset_info()
DatasetInfo(description=<span class="hljs-string">&quot;Movie Review Dataset.
a dataset of containing 5,331 positive and 5,331 negative processed
s from Rotten Tomatoes movie reviews. This data was first used in Bo
 Lillian Lee, \`\`Seeing stars: Exploiting class relationships for
t categorization with respect to rating scales.&#x27;&#x27;, Proceedings of the
5.
ion=&#x27;@InProceedings{Pang+Lee:05a,
 =       {Bo Pang and Lillian Lee},
=        {Seeing stars: Exploiting class relationships for sentiment
          categorization with respect to rating scales},
tle =    {Proceedings of the ACL},
         2005

age=&#x27;http://www.cs.cornell.edu/people/pabo/movie-review-data/&#x27;, license=&#x27;&#x27;, features={&#x27;text&#x27;: Value(dtype=&#x27;string&#x27;, id=None), &#x27;label&#x27;: ClassLabel(num_classes=2, names=[&#x27;neg&#x27;, &#x27;pos&#x27;], id=None)}, post_processed=None, supervised_keys=SupervisedKeysData(input=&#x27;&#x27;, output=&#x27;&#x27;), task_templates=[TextClassification(task=&#x27;text-classification&#x27;, text_column=&#x27;text&#x27;, label_column=&#x27;label&#x27;)], builder_name=&#x27;rotten_tomatoes_movie_review&#x27;, config_name=&#x27;default&#x27;, version=1.0.0, splits={&#x27;train&#x27;: SplitInfo(name=&#x27;train&#x27;, num_bytes=1074810, num_examples=8530, dataset_name=&#x27;rotten_tomatoes_movie_review&#x27;), &#x27;validation&#x27;: SplitInfo(name=&#x27;validation&#x27;, num_bytes=134679, num_examples=1066, dataset_name=&#x27;rotten_tomatoes_movie_review&#x27;), &#x27;test&#x27;: SplitInfo(name=&#x27;test&#x27;, num_bytes=135972, num_examples=1066, dataset_name=&#x27;rotten_tomatoes_movie_review&#x27;)}, download_checksums={&#x27;https://storage.googleapis.com/seldon-datasets/sentence_polarity_v1/rt-polaritydata.tar.gz&#x27;: {&#x27;num_bytes&#x27;: 487770, &#x27;checksum&#x27;: &#x27;a05befe52aafda71d458d188a1c54506a998b1308613ba76bbda2e5029409ce9&#x27;}}, download_size=487770, post_processing_size=None, dataset_size=1345461, size_in_bytes=1833231)</span>`}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function hg(k){let l,_,f,n,u;return n=new I({props:{code:"downloaded_files = dl_manager.download('https://storage.googleapis.com/seldon-datasets/sentence_polarity_v1/rt-polaritydata.tar.gz')",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>downloaded_files = dl_manager.download(<span class="hljs-string">&#x27;https://storage.googleapis.com/seldon-datasets/sentence_polarity_v1/rt-polaritydata.tar.gz&#x27;</span>)'}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function $g(k){let l,_,f,n,u;return n=new I({props:{code:"extracted_paths = dl_manager.extract(dl_manager.download(url_or_urls))",highlighted:'<span class="hljs-attr">extracted_paths</span> = dl_manager.extract(dl_manager.download(url_or_urls))'}}),{c(){l=o("p"),_=c("Is roughly equivalent to:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Is roughly equivalent to:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function bg(k){let l,_,f,n,u;return n=new I({props:{code:"downloaded_files = dl_manager.download_custom('s3://my-bucket/data.zip', custom_download_for_my_private_bucket)",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>downloaded_files = dl_manager.download_custom(<span class="hljs-string">&#x27;s3://my-bucket/data.zip&#x27;</span>, custom_download_for_my_private_bucket)'}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function vg(k){let l,_,f,n,u;return n=new I({props:{code:`downloaded_files = dl_manager.download('https://storage.googleapis.com/seldon-datasets/sentence_polarity_v1/rt-polaritydata.tar.gz')
extracted_files = dl_manager.extract(downloaded_files)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>downloaded_files = dl_manager.download(<span class="hljs-string">&#x27;https://storage.googleapis.com/seldon-datasets/sentence_polarity_v1/rt-polaritydata.tar.gz&#x27;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>extracted_files = dl_manager.extract(downloaded_files)`}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function wg(k){let l,_,f,n,u;return n=new I({props:{code:`archive = dl_manager.download('https://storage.googleapis.com/seldon-datasets/sentence_polarity_v1/rt-polaritydata.tar.gz')
files = dl_manager.iter_archive(archive)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>archive = dl_manager.download(<span class="hljs-string">&#x27;https://storage.googleapis.com/seldon-datasets/sentence_polarity_v1/rt-polaritydata.tar.gz&#x27;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>files = dl_manager.iter_archive(archive)`}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function xg(k){let l,_,f,n,u;return n=new I({props:{code:`files = dl_manager.download_and_extract('https://huggingface.co/datasets/beans/resolve/main/data/train.zip')
files = dl_manager.iter_files(files)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>files = dl_manager.download_and_extract(<span class="hljs-string">&#x27;https://huggingface.co/datasets/beans/resolve/main/data/train.zip&#x27;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>files = dl_manager.iter_files(files)`}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function Dg(k){let l,_,f,n,u;return n=new I({props:{code:"downloaded_files = dl_manager.download('https://storage.googleapis.com/seldon-datasets/sentence_polarity_v1/rt-polaritydata.tar.gz')",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>downloaded_files = dl_manager.download(<span class="hljs-string">&#x27;https://storage.googleapis.com/seldon-datasets/sentence_polarity_v1/rt-polaritydata.tar.gz&#x27;</span>)'}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function Eg(k){let l,_,f,n,u;return n=new I({props:{code:"urls = dl_manager.extract(dl_manager.download(url_or_urls))",highlighted:'<span class="hljs-attribute">urls</span> <span class="hljs-operator">=</span> dl_manager.extract(dl_manager.download(url_or_urls))'}}),{c(){l=o("p"),_=c("Is equivalent to:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Is equivalent to:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function yg(k){let l,_,f,n,u;return n=new I({props:{code:`downloaded_files = dl_manager.download('https://storage.googleapis.com/seldon-datasets/sentence_polarity_v1/rt-polaritydata.tar.gz')
extracted_files = dl_manager.extract(downloaded_files)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>downloaded_files = dl_manager.download(<span class="hljs-string">&#x27;https://storage.googleapis.com/seldon-datasets/sentence_polarity_v1/rt-polaritydata.tar.gz&#x27;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>extracted_files = dl_manager.extract(downloaded_files)`}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function kg(k){let l,_,f,n,u;return n=new I({props:{code:`archive = dl_manager.download('https://storage.googleapis.com/seldon-datasets/sentence_polarity_v1/rt-polaritydata.tar.gz')
files = dl_manager.iter_archive(archive)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>archive = dl_manager.download(<span class="hljs-string">&#x27;https://storage.googleapis.com/seldon-datasets/sentence_polarity_v1/rt-polaritydata.tar.gz&#x27;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>files = dl_manager.iter_archive(archive)`}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function jg(k){let l,_,f,n,u;return n=new I({props:{code:`files = dl_manager.download_and_extract('https://huggingface.co/datasets/beans/resolve/main/data/train.zip')
files = dl_manager.iter_files(files)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>files = dl_manager.download_and_extract(<span class="hljs-string">&#x27;https://huggingface.co/datasets/beans/resolve/main/data/train.zip&#x27;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>files = dl_manager.iter_files(files)`}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function Tg(k){let l,_,f,n,u;return n=new I({props:{code:`datasets.SplitGenerator(
    name=datasets.Split.TRAIN,
    gen_kwargs={"split_key": "train", "files": dl_manager.download_and_extract(url)},
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>datasets.SplitGenerator(
<span class="hljs-meta">... </span>    name=datasets.Split.TRAIN,
<span class="hljs-meta">... </span>    gen_kwargs={<span class="hljs-string">&quot;split_key&quot;</span>: <span class="hljs-string">&quot;train&quot;</span>, <span class="hljs-string">&quot;files&quot;</span>: dl_manager.download_and_extract(url)},
<span class="hljs-meta">... </span>)`}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function Sg(k){let l,_,f,n,u;return n=new I({props:{code:`datasets.SplitGenerator(
    name=datasets.Split.TRAIN,
    gen_kwargs={"split_key": "train", "files": dl_manager.download_and extract(url)},
),
datasets.SplitGenerator(
    name=datasets.Split.VALIDATION,
    gen_kwargs={"split_key": "validation", "files": dl_manager.download_and extract(url)},
),
datasets.SplitGenerator(
    name=datasets.Split.TEST,
    gen_kwargs={"split_key": "test", "files": dl_manager.download_and extract(url)},
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>datasets.SplitGenerator(
<span class="hljs-meta">... </span>    name=datasets.Split.TRAIN,
<span class="hljs-meta">... </span>    gen_kwargs={<span class="hljs-string">&quot;split_key&quot;</span>: <span class="hljs-string">&quot;train&quot;</span>, <span class="hljs-string">&quot;files&quot;</span>: dl_manager.download_and extract(url)},
<span class="hljs-meta">... </span>),
<span class="hljs-meta">... </span>datasets.SplitGenerator(
<span class="hljs-meta">... </span>    name=datasets.Split.VALIDATION,
<span class="hljs-meta">... </span>    gen_kwargs={<span class="hljs-string">&quot;split_key&quot;</span>: <span class="hljs-string">&quot;validation&quot;</span>, <span class="hljs-string">&quot;files&quot;</span>: dl_manager.download_and extract(url)},
<span class="hljs-meta">... </span>),
<span class="hljs-meta">... </span>datasets.SplitGenerator(
<span class="hljs-meta">... </span>    name=datasets.Split.TEST,
<span class="hljs-meta">... </span>    gen_kwargs={<span class="hljs-string">&quot;split_key&quot;</span>: <span class="hljs-string">&quot;test&quot;</span>, <span class="hljs-string">&quot;files&quot;</span>: dl_manager.download_and extract(url)},
<span class="hljs-meta">... </span>)`}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function Ig(k){let l,_,f,n,u;return n=new I({props:{code:"split = datasets.Split.TRAIN.subsplit(datasets.percent[0:25]) + datasets.Split.TEST",highlighted:'split = datasets.Split.TRAIN.subsplit(datasets.percent[<span class="hljs-number">0</span>:<span class="hljs-number">25</span>]) + datasets.Split.TEST'}}),{c(){l=o("p"),_=c("Each descriptor can be composed with other using addition or slice:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Each descriptor can be composed with other using addition or slice:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function Bg(k){let l,_,f,n,u;return n=new I({props:{code:`split = (
        datasets.Split.TRAIN.subsplit(datasets.percent[:25]) +
        datasets.Split.TRAIN.subsplit(datasets.percent[75:])
)  # Error
split = datasets.Split.TEST + datasets.Split.ALL  # Error`,highlighted:`split = (
        datasets.Split.TRAIN.subsplit(datasets.percent[:<span class="hljs-number">25</span>]) +
        datasets.Split.TRAIN.subsplit(datasets.percent[<span class="hljs-number">75</span>:])
)  <span class="hljs-comment"># Error</span>
split = datasets.Split.TEST + datasets.Split.ALL  <span class="hljs-comment"># Error</span>`}}),{c(){l=o("p"),_=c("A split cannot be added twice, so the following will fail:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"A split cannot be added twice, so the following will fail:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function Ng(k){let l,_,f,n,u;return n=new I({props:{code:`split = (
        datasets.Split.TRAIN.subsplit(datasets.percent[:25]) +
        datasets.Split.TEST.subsplit(datasets.percent[:50])
)
split = (datasets.Split.TRAIN + datasets.Split.TEST).subsplit(datasets.percent[:50])`,highlighted:`split = (
        datasets.Split.TRAIN.subsplit(datasets.percent[:<span class="hljs-number">25</span>]) +
        datasets.Split.TEST.subsplit(datasets.percent[:<span class="hljs-number">50</span>])
)
split = (datasets.Split.TRAIN + datasets.Split.TEST).subsplit(datasets.percent[:<span class="hljs-number">50</span>])`}}),{c(){l=o("p"),_=c("The slices can be applied only one time. So the following are valid:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"The slices can be applied only one time. So the following are valid:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function Pg(k){let l,_,f,n,u;return n=new I({props:{code:`train = datasets.Split.TRAIN
test = datasets.Split.TEST
split = train.subsplit(datasets.percent[:25]).subsplit(datasets.percent[:25])
split = (train.subsplit(datasets.percent[:25]) + test).subsplit(datasets.percent[:50])`,highlighted:`train = datasets.Split.TRAIN
test = datasets.Split.TEST
split = train.subsplit(datasets.percent[:<span class="hljs-number">25</span>]).subsplit(datasets.percent[:<span class="hljs-number">25</span>])
split = (train.subsplit(datasets.percent[:<span class="hljs-number">25</span>]) + test).subsplit(datasets.percent[:<span class="hljs-number">50</span>])`}}),{c(){l=o("p"),_=c("But this is not valid:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"But this is not valid:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function Cg(k){let l,_,f,n,u;return n=new I({props:{code:`# The following lines are equivalent:
ds = datasets.load_dataset('mnist', split='test[:33%]')
ds = datasets.load_dataset('mnist', split=datasets.ReadInstruction.from_spec('test[:33%]'))
ds = datasets.load_dataset('mnist', split=datasets.ReadInstruction('test', to=33, unit='%'))
ds = datasets.load_dataset('mnist', split=datasets.ReadInstruction(
'test', from_=0, to=33, unit='%'))

# The following lines are equivalent:
ds = datasets.load_dataset('mnist', split='test[:33%]+train[1:-1]')
ds = datasets.load_dataset('mnist', split=datasets.ReadInstruction.from_spec(
'test[:33%]+train[1:-1]'))
ds = datasets.load_dataset('mnist', split=(
datasets.ReadInstruction('test', to=33, unit='%') +
datasets.ReadInstruction('train', from_=1, to=-1, unit='abs')))

# The following lines are equivalent:
ds = datasets.load_dataset('mnist', split='test[:33%](pct1_dropremainder)')
ds = datasets.load_dataset('mnist', split=datasets.ReadInstruction.from_spec(
'test[:33%](pct1_dropremainder)'))
ds = datasets.load_dataset('mnist', split=datasets.ReadInstruction(
'test', from_=0, to=33, unit='%', rounding="pct1_dropremainder"))

# 10-fold validation:
tests = datasets.load_dataset(
'mnist',
[datasets.ReadInstruction('train', from_=k, to=k+10, unit='%')
for k in range(0, 100, 10)])
trains = datasets.load_dataset(
'mnist',
[datasets.ReadInstruction('train', to=k, unit='%') + datasets.ReadInstruction('train', from_=k+10, unit='%')
for k in range(0, 100, 10)])`,highlighted:`<span class="hljs-comment"># The following lines are equivalent:</span>
ds = datasets.load_dataset(<span class="hljs-string">&#x27;mnist&#x27;</span>, split=<span class="hljs-string">&#x27;test[:33%]&#x27;</span>)
ds = datasets.load_dataset(<span class="hljs-string">&#x27;mnist&#x27;</span>, split=datasets.ReadInstruction.from_spec(<span class="hljs-string">&#x27;test[:33%]&#x27;</span>))
ds = datasets.load_dataset(<span class="hljs-string">&#x27;mnist&#x27;</span>, split=datasets.ReadInstruction(<span class="hljs-string">&#x27;test&#x27;</span>, to=<span class="hljs-number">33</span>, unit=<span class="hljs-string">&#x27;%&#x27;</span>))
ds = datasets.load_dataset(<span class="hljs-string">&#x27;mnist&#x27;</span>, split=datasets.ReadInstruction(
<span class="hljs-string">&#x27;test&#x27;</span>, from_=<span class="hljs-number">0</span>, to=<span class="hljs-number">33</span>, unit=<span class="hljs-string">&#x27;%&#x27;</span>))

<span class="hljs-comment"># The following lines are equivalent:</span>
ds = datasets.load_dataset(<span class="hljs-string">&#x27;mnist&#x27;</span>, split=<span class="hljs-string">&#x27;test[:33%]+train[1:-1]&#x27;</span>)
ds = datasets.load_dataset(<span class="hljs-string">&#x27;mnist&#x27;</span>, split=datasets.ReadInstruction.from_spec(
<span class="hljs-string">&#x27;test[:33%]+train[1:-1]&#x27;</span>))
ds = datasets.load_dataset(<span class="hljs-string">&#x27;mnist&#x27;</span>, split=(
datasets.ReadInstruction(<span class="hljs-string">&#x27;test&#x27;</span>, to=<span class="hljs-number">33</span>, unit=<span class="hljs-string">&#x27;%&#x27;</span>) +
datasets.ReadInstruction(<span class="hljs-string">&#x27;train&#x27;</span>, from_=<span class="hljs-number">1</span>, to=-<span class="hljs-number">1</span>, unit=<span class="hljs-string">&#x27;abs&#x27;</span>)))

<span class="hljs-comment"># The following lines are equivalent:</span>
ds = datasets.load_dataset(<span class="hljs-string">&#x27;mnist&#x27;</span>, split=<span class="hljs-string">&#x27;test[:33%](pct1_dropremainder)&#x27;</span>)
ds = datasets.load_dataset(<span class="hljs-string">&#x27;mnist&#x27;</span>, split=datasets.ReadInstruction.from_spec(
<span class="hljs-string">&#x27;test[:33%](pct1_dropremainder)&#x27;</span>))
ds = datasets.load_dataset(<span class="hljs-string">&#x27;mnist&#x27;</span>, split=datasets.ReadInstruction(
<span class="hljs-string">&#x27;test&#x27;</span>, from_=<span class="hljs-number">0</span>, to=<span class="hljs-number">33</span>, unit=<span class="hljs-string">&#x27;%&#x27;</span>, rounding=<span class="hljs-string">&quot;pct1_dropremainder&quot;</span>))

<span class="hljs-comment"># 10-fold validation:</span>
tests = datasets.load_dataset(
<span class="hljs-string">&#x27;mnist&#x27;</span>,
[datasets.ReadInstruction(<span class="hljs-string">&#x27;train&#x27;</span>, from_=k, to=k+<span class="hljs-number">10</span>, unit=<span class="hljs-string">&#x27;%&#x27;</span>)
<span class="hljs-keyword">for</span> k <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">0</span>, <span class="hljs-number">100</span>, <span class="hljs-number">10</span>)])
trains = datasets.load_dataset(
<span class="hljs-string">&#x27;mnist&#x27;</span>,
[datasets.ReadInstruction(<span class="hljs-string">&#x27;train&#x27;</span>, to=k, unit=<span class="hljs-string">&#x27;%&#x27;</span>) + datasets.ReadInstruction(<span class="hljs-string">&#x27;train&#x27;</span>, from_=k+<span class="hljs-number">10</span>, unit=<span class="hljs-string">&#x27;%&#x27;</span>)
<span class="hljs-keyword">for</span> k <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">0</span>, <span class="hljs-number">100</span>, <span class="hljs-number">10</span>)])`}}),{c(){l=o("p"),_=c("Examples:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Examples:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function Rg(k){let l,_,f,n,u;return n=new I({props:{code:`test: test split.
test + validation: test split + validation split.
test[10:]: test split, minus its first 10 records.
test[:10%]: first 10% records of test split.
test[:20%](pct1_dropremainder): first 10% records, rounded with the pct1_dropremainder rounding.
test[:-5%]+train[40%:60%]: first 95% of test + middle 20% of train.`,highlighted:`<span class="hljs-keyword">test: test</span> split.
<span class="hljs-keyword">test </span>+ validation: test split + validation split.
test[10:]: test split, minus its first 10 records.
test[:10%]: first 10% records of test split.
test[:20%](pct1_dropremainder): first 10% records, rounded with the pct1_dropremainder rounding.
test[:<span class="hljs-string">-5</span>%]+train[40%:60%]: first 95% of test + middle 20% of train.`}}),{c(){l=o("p"),_=c("Examples:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Examples:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function Lg(k){let l,_,f,n,u;return n=new I({props:{code:'VERSION = datasets.Version("1.0.0")',highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>VERSION = datasets.Version(<span class="hljs-string">&quot;1.0.0&quot;</span>)'}}),{c(){l=o("p"),_=c("Example:"),f=m(),b(n.$$.fragment)},l(t){l=r(t,"P",{});var i=d(l);_=p(i,"Example:"),i.forEach(a),f=g(t),v(n.$$.fragment,t)},m(t,i){$(t,l,i),e(l,_),$(t,f,i),w(n,t,i),u=!0},p:S,i(t){u||(x(n.$$.fragment,t),u=!0)},o(t){D(n.$$.fragment,t),u=!1},d(t){t&&a(l),t&&a(f),E(n,t)}}}function Ag(k){let l,_,f,n,u,t,i,de,R,H,K,Ue,ws,It,fn,xs,un,xr,le,_n,Pa,hn,$n,Ca,bn,vn,Dr,B,Bt,wn,Ds,xn,Dn,Ra,Es,En,yn,kn,ye,La,ys,jn,Tn,Sn,Aa,Oa,In,Bn,Nn,ze,qa,Pn,Cn,Ma,Rn,Ln,An,ae,On,ks,qn,Mn,Va,Vn,Un,js,zn,Fn,Gn,ie,Nt,Hn,Ts,Wn,Xn,Fe,Kn,O,Pt,Jn,Ss,Yn,Qn,Is,Zn,ed,Ge,td,He,ad,We,sd,ce,Ct,od,Bs,rd,nd,Xe,dd,pe,Rt,ld,Lt,id,Ns,cd,pd,md,Ke,gd,Je,At,fd,Ps,ud,Er,se,Ot,_d,Cs,hd,$d,me,Rs,bd,vd,Ls,wd,xd,As,Dd,Ed,yr,ke,qt,yd,Os,kd,kr,je,Mt,jd,qs,Td,jr,W,Vt,Sd,Ut,Id,Ms,Bd,Nd,Pd,Ye,Vs,Cd,Rd,Us,Ld,Ad,Od,J,zt,qd,zs,Md,Vd,Te,Fs,Ud,zd,Gs,Fd,Gd,Hs,Hd,Wd,Ws,Xd,Tr,Se,Qe,Xs,Ft,Kd,Ks,Jd,Sr,P,Gt,Yd,Y,Ht,Qd,Js,Zd,el,Wt,tl,Ys,al,sl,ol,Ze,rl,ge,Xt,nl,Kt,dl,Qs,ll,il,cl,et,pl,fe,Jt,ml,Yt,gl,Zs,fl,ul,_l,tt,hl,ue,Qt,$l,eo,bl,vl,at,wl,_e,Zt,xl,to,Dl,El,st,yl,he,ea,kl,ao,jl,Tl,ot,Sl,rt,ta,Il,so,Bl,Ir,L,aa,Nl,V,Pl,oo,Cl,Rl,ro,Ll,Al,no,Ol,ql,lo,Ml,Vl,io,Ul,zl,Fl,$e,sa,Gl,oa,Hl,co,Wl,Xl,Kl,nt,Jl,Q,ra,Yl,na,Ql,po,Zl,ei,ti,da,ai,mo,si,oi,ri,dt,ni,Z,la,di,go,li,ii,ia,ci,fo,pi,mi,gi,lt,fi,be,ca,ui,uo,_i,hi,it,$i,ve,pa,bi,_o,vi,wi,ct,Br,Ie,ma,xi,ho,Di,Nr,U,ga,Ei,Ua,$o,yi,ki,ji,fa,Ti,bo,Si,Ii,Bi,vo,Ni,Pi,ua,wo,Be,Pr,Ci,xo,Ri,Li,Do,Ai,Oi,Ne,Pe,za,Eo,qi,Mi,Vi,yo,Ui,zi,ko,Fi,Gi,Ce,jo,To,Hi,Wi,So,Xi,Ki,Io,Ji,Yi,Re,Bo,No,Qi,Zi,Po,ec,tc,Co,ac,Cr,Le,pt,Ro,_a,sc,Lo,oc,Rr,X,ha,rc,Ao,nc,dc,Ae,lc,Oo,ic,cc,qo,pc,mc,gc,mt,Lr,A,$a,fc,Fa,Mo,uc,_c,hc,Vo,$c,bc,oe,Ga,Uo,vc,wc,xc,Ha,zo,Dc,Ec,yc,Wa,Fo,kc,jc,Tc,Xa,Go,Sc,Ic,Bc,ba,Nc,Ho,Pc,Cc,Rc,va,Lc,Ka,Ac,Oc,qc,gt,Ar,C,wa,Mc,Wo,Vc,Uc,Xo,zc,Fc,ft,Gc,Ko,Hc,Wc,ut,Xc,_t,Kc,ht,Or,Oe,xa,Jc,Jo,Yc,qr,z,Da,Qc,Yo,Zc,ep,$t,tp,we,Ea,ap,ya,sp,Qo,op,rp,np,bt,dp,xe,ka,lp,Zo,ip,cp,er,pp,Mr,qe,vt,tr,ja,mp,ar,gp,Vr,re,Ta,fp,Sa,up,sr,_p,hp,$p,wt,Ur;return t=new wr({}),It=new wr({}),Bt=new j({props:{name:"class datasets.DatasetBuilder",anchor:"datasets.DatasetBuilder",parameters:[{name:"cache_dir",val:": typing.Optional[str] = None"},{name:"config_name",val:": typing.Optional[str] = None"},{name:"hash",val:": typing.Optional[str] = None"},{name:"base_path",val:": typing.Optional[str] = None"},{name:"info",val:": typing.Optional[datasets.info.DatasetInfo] = None"},{name:"features",val:": typing.Optional[datasets.features.features.Features] = None"},{name:"use_auth_token",val:": typing.Union[str, bool, NoneType] = None"},{name:"repo_id",val:": typing.Optional[str] = None"},{name:"data_files",val:": typing.Union[str, list, dict, datasets.data_files.DataFilesDict, NoneType] = None"},{name:"data_dir",val:": typing.Optional[str] = None"},{name:"name",val:" = 'deprecated'"},{name:"**config_kwargs",val:""}],parametersDescription:[{anchor:"datasets.DatasetBuilder.cache_dir",description:`<strong>cache_dir</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Directory to cache data. Defaults to <code>&quot;~/.cache/huggingface/datasets&quot;</code>.`,name:"cache_dir"},{anchor:"datasets.DatasetBuilder.config_name",description:`<strong>config_name</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Name of the dataset configuration.
It affects the data generated on disk. Different configurations will have their own subdirectories and
versions.
If not provided, the default configuration is used (if it exists).</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						<p class="font-medium">Added in 2.3.0</p>
						
<p>Parameter <code>name</code> was renamed to <code>config_name</code>.</p>

					</div>`,name:"config_name"},{anchor:"datasets.DatasetBuilder.hash",description:`<strong>hash</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Hash specific to the dataset code. Used to update the caching directory when the
dataset loading script code is updated (to avoid reusing old data).
The typical caching directory (defined in <code>self._relative_data_dir</code>) is <code>name/version/hash/</code>.`,name:"hash"},{anchor:"datasets.DatasetBuilder.base_path",description:`<strong>base_path</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Base path for relative paths that are used to download files.
This can be a remote URL.`,name:"base_path"},{anchor:"datasets.DatasetBuilder.features",description:`<strong>features</strong> (<a href="/docs/datasets/main/en/package_reference/main_classes#datasets.Features">Features</a>, <em>optional</em>) &#x2014;
Features types to use with this dataset.
It can be used to change the <a href="/docs/datasets/main/en/package_reference/main_classes#datasets.Features">Features</a> types of a dataset, for example.`,name:"features"},{anchor:"datasets.DatasetBuilder.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <code>bool</code>, <em>optional</em>) &#x2014;
String or boolean to use as Bearer token for remote files on the
Datasets Hub. If <code>True</code>, will get token from <code>&quot;~/.huggingface&quot;</code>.`,name:"use_auth_token"},{anchor:"datasets.DatasetBuilder.repo_id",description:`<strong>repo_id</strong> (<code>str</code>, <em>optional</em>) &#x2014;
ID of the dataset repository.
Used to distinguish builders with the same name but not coming from the same namespace, for example &#x201C;squad&#x201D;
and &#x201C;lhoestq/squad&#x201D; repo IDs. In the latter, the builder name would be &#x201C;lhoestq___squad&#x201D;.`,name:"repo_id"},{anchor:"datasets.DatasetBuilder.data_files",description:`<strong>data_files</strong> (<code>str</code> or <code>Sequence</code> or <code>Mapping</code>, <em>optional</em>) &#x2014;
Path(s) to source data file(s).
For builders like &#x201C;csv&#x201D; or &#x201C;json&#x201D; that need the user to specify data files. They can be either
local or remote files. For convenience, you can use a <code>DataFilesDict</code>.`,name:"data_files"},{anchor:"datasets.DatasetBuilder.data_dir",description:`<strong>data_dir</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Path to directory containing source data file(s).
Use only if <code>data_files</code> is not passed, in which case it is equivalent to passing
<code>os.path.join(data_dir, &quot;**&quot;)</code> as <code>data_files</code>.
For builders that require manual download, it must be the path to the local directory containing the
manually downloaded data.`,name:"data_dir"},{anchor:"datasets.DatasetBuilder.name",description:`<strong>name</strong> (<code>str</code>) &#x2014; Configuration name for the dataset.</p>
<div class="course-tip course-tip-orange bg-gradient-to-br dark:bg-gradient-to-r before:border-orange-500 dark:before:border-orange-800 from-orange-50 dark:from-gray-900 to-white dark:to-gray-950 border border-orange-50 text-orange-700 dark:text-gray-400">
						<p class="font-medium">Deprecated in 2.3.0</p>
						
<p>Use <code>config_name</code> instead.</p>

					</div>`,name:"name"},{anchor:"datasets.DatasetBuilder.*config_kwargs",description:`*<strong>*config_kwargs</strong> (additional keyword arguments) &#x2014; Keyword arguments to be passed to the corresponding builder
configuration class, set on the class attribute <a href="/docs/datasets/main/en/package_reference/builder_classes#datasets.BuilderConfig">DatasetBuilder.BUILDER_CONFIG_CLASS</a>. The builder
configuration class is <a href="/docs/datasets/main/en/package_reference/builder_classes#datasets.BuilderConfig">BuilderConfig</a> or a subclass of it.`,name:"*config_kwargs"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/builder.py#L197"}}),Nt=new j({props:{name:"as_dataset",anchor:"datasets.DatasetBuilder.as_dataset",parameters:[{name:"split",val:": typing.Optional[datasets.splits.Split] = None"},{name:"run_post_process",val:" = True"},{name:"ignore_verifications",val:" = False"},{name:"in_memory",val:" = False"}],parametersDescription:[{anchor:"datasets.DatasetBuilder.as_dataset.split",description:`<strong>split</strong> (<code>datasets.Split</code>) &#x2014;
Which subset of the data to return.`,name:"split"},{anchor:"datasets.DatasetBuilder.as_dataset.run_post_process",description:`<strong>run_post_process</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to run post-processing dataset transforms and/or add
indexes.`,name:"run_post_process"},{anchor:"datasets.DatasetBuilder.as_dataset.ignore_verifications",description:`<strong>ignore_verifications</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to ignore the verifications of the
downloaded/processed dataset information (checksums/size/splits/&#x2026;).`,name:"ignore_verifications"},{anchor:"datasets.DatasetBuilder.as_dataset.in_memory",description:`<strong>in_memory</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to copy the data in-memory.`,name:"in_memory"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/builder.py#L1015",returnDescription:`
<p>datasets.Dataset</p>
`}}),Fe=new T({props:{anchor:"datasets.DatasetBuilder.as_dataset.example",$$slots:{default:[pg]},$$scope:{ctx:k}}}),Pt=new j({props:{name:"download_and_prepare",anchor:"datasets.DatasetBuilder.download_and_prepare",parameters:[{name:"output_dir",val:": typing.Optional[str] = None"},{name:"download_config",val:": typing.Optional[datasets.download.download_config.DownloadConfig] = None"},{name:"download_mode",val:": typing.Optional[datasets.download.download_manager.DownloadMode] = None"},{name:"ignore_verifications",val:": bool = False"},{name:"try_from_hf_gcs",val:": bool = True"},{name:"dl_manager",val:": typing.Optional[datasets.download.download_manager.DownloadManager] = None"},{name:"base_path",val:": typing.Optional[str] = None"},{name:"use_auth_token",val:" = 'deprecated'"},{name:"file_format",val:": str = 'arrow'"},{name:"max_shard_size",val:": typing.Union[str, int, NoneType] = None"},{name:"num_proc",val:": typing.Optional[int] = None"},{name:"storage_options",val:": typing.Optional[dict] = None"},{name:"**download_and_prepare_kwargs",val:""}],parametersDescription:[{anchor:"datasets.DatasetBuilder.download_and_prepare.output_dir",description:`<strong>output_dir</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Output directory for the dataset.
Default to this builder&#x2019;s <code>cache_dir</code>, which is inside <code>~/.cache/huggingface/datasets</code> by default.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						<p class="font-medium">Added in 2.5.0</p>
						
					</div>`,name:"output_dir"},{anchor:"datasets.DatasetBuilder.download_and_prepare.download_config",description:`<strong>download_config</strong> (<code>DownloadConfig</code>, <em>optional</em>) &#x2014;
Specific download configuration parameters.`,name:"download_config"},{anchor:"datasets.DatasetBuilder.download_and_prepare.download_mode",description:`<strong>download_mode</strong> (<code>DownloadMode</code>, <em>optional</em>) &#x2014;
Select the download/generate mode, default to <code>REUSE_DATASET_IF_EXISTS</code>.`,name:"download_mode"},{anchor:"datasets.DatasetBuilder.download_and_prepare.ignore_verifications",description:`<strong>ignore_verifications</strong> (<code>bool</code>) &#x2014;
Ignore the verifications of the downloaded/processed dataset information (checksums/size/splits/&#x2026;).`,name:"ignore_verifications"},{anchor:"datasets.DatasetBuilder.download_and_prepare.try_from_hf_gcs",description:`<strong>try_from_hf_gcs</strong> (<code>bool</code>) &#x2014;
If <code>True</code>, it will try to download the already prepared dataset from the HF Google cloud storage.`,name:"try_from_hf_gcs"},{anchor:"datasets.DatasetBuilder.download_and_prepare.dl_manager",description:`<strong>dl_manager</strong> (<code>DownloadManager</code>, <em>optional</em>) &#x2014;
Specific <code>DownloadManger</code> to use.`,name:"dl_manager"},{anchor:"datasets.DatasetBuilder.download_and_prepare.base_path",description:`<strong>base_path</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Base path for relative paths that are used to download files. This can be a remote url.
If not specified, the value of the <code>base_path</code> attribute (<code>self.base_path</code>) will be used instead.`,name:"base_path"},{anchor:"datasets.DatasetBuilder.download_and_prepare.use_auth_token",description:`<strong>use_auth_token</strong> (<code>Union[str, bool]</code>, <em>optional</em>) &#x2014;
Optional string or boolean to use as Bearer token for remote files on the Datasets Hub.
If True, or not specified, will get token from ~/.huggingface.</p>
<div class="course-tip course-tip-orange bg-gradient-to-br dark:bg-gradient-to-r before:border-orange-500 dark:before:border-orange-800 from-orange-50 dark:from-gray-900 to-white dark:to-gray-950 border border-orange-50 text-orange-700 dark:text-gray-400">
						<p class="font-medium">Deprecated in 2.7.1</p>
						
<p>Pass <code>use_auth_token</code> to the initializer/<code>load_dataset_builder</code> instead.</p>

					</div>`,name:"use_auth_token"},{anchor:"datasets.DatasetBuilder.download_and_prepare.file_format",description:`<strong>file_format</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Format of the data files in which the dataset will be written.
Supported formats: &#x201C;arrow&#x201D;, &#x201C;parquet&#x201D;. Default to &#x201C;arrow&#x201D; format.
If the format is &#x201C;parquet&#x201D;, then image and audio data are embedded into the Parquet files instead of pointing to local files.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						<p class="font-medium">Added in 2.5.0</p>
						
					</div>`,name:"file_format"},{anchor:"datasets.DatasetBuilder.download_and_prepare.max_shard_size",description:`<strong>max_shard_size</strong> (<code>Union[str, int]</code>, <em>optional</em>) &#x2014;
Maximum number of bytes written per shard, default is &#x201C;500MB&#x201D;.
The size is based on uncompressed data size, so in practice your shard files may be smaller than
<code>max_shard_size</code> thanks to Parquet compression for example.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						<p class="font-medium">Added in 2.5.0</p>
						
					</div>`,name:"max_shard_size"},{anchor:"datasets.DatasetBuilder.download_and_prepare.num_proc",description:`<strong>num_proc</strong> (<code>int</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Number of processes when downloading and generating the dataset locally.
Multiprocessing is disabled by default.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						<p class="font-medium">Added in 2.7.0</p>
						
					</div>`,name:"num_proc"},{anchor:"datasets.DatasetBuilder.download_and_prepare.storage_options",description:`<strong>storage_options</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Key/value pairs to be passed on to the caching file-system backend, if any.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						<p class="font-medium">Added in 2.5.0</p>
						
					</div>`,name:"storage_options"},{anchor:"datasets.DatasetBuilder.download_and_prepare.*download_and_prepare_kwargs",description:"*<strong>*download_and_prepare_kwargs</strong> (additional keyword arguments) &#x2014; Keyword arguments.",name:"*download_and_prepare_kwargs"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/builder.py#L615"}}),Ge=new T({props:{anchor:"datasets.DatasetBuilder.download_and_prepare.example",$$slots:{default:[mg]},$$scope:{ctx:k}}}),He=new T({props:{anchor:"datasets.DatasetBuilder.download_and_prepare.example-2",$$slots:{default:[gg]},$$scope:{ctx:k}}}),We=new T({props:{anchor:"datasets.DatasetBuilder.download_and_prepare.example-3",$$slots:{default:[fg]},$$scope:{ctx:k}}}),Ct=new j({props:{name:"get_all_exported_dataset_infos",anchor:"datasets.DatasetBuilder.get_all_exported_dataset_infos",parameters:[],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/builder.py#L404"}}),Xe=new T({props:{anchor:"datasets.DatasetBuilder.get_all_exported_dataset_infos.example",$$slots:{default:[ug]},$$scope:{ctx:k}}}),Rt=new j({props:{name:"get_exported_dataset_info",anchor:"datasets.DatasetBuilder.get_exported_dataset_info",parameters:[],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/builder.py#L419"}}),Ke=new T({props:{anchor:"datasets.DatasetBuilder.get_exported_dataset_info.example",$$slots:{default:[_g]},$$scope:{ctx:k}}}),At=new j({props:{name:"get_imported_module_dir",anchor:"datasets.DatasetBuilder.get_imported_module_dir",parameters:[],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/builder.py#L602"}}),Ot=new j({props:{name:"class datasets.GeneratorBasedBuilder",anchor:"datasets.GeneratorBasedBuilder",parameters:[{name:"*args",val:""},{name:"writer_batch_size",val:" = None"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/builder.py#L1338"}}),qt=new j({props:{name:"class datasets.BeamBasedBuilder",anchor:"datasets.BeamBasedBuilder",parameters:[{name:"*args",val:""},{name:"beam_runner",val:" = None"},{name:"beam_options",val:" = None"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/builder.py#L1863"}}),Mt=new j({props:{name:"class datasets.ArrowBasedBuilder",anchor:"datasets.ArrowBasedBuilder",parameters:[{name:"cache_dir",val:": typing.Optional[str] = None"},{name:"config_name",val:": typing.Optional[str] = None"},{name:"hash",val:": typing.Optional[str] = None"},{name:"base_path",val:": typing.Optional[str] = None"},{name:"info",val:": typing.Optional[datasets.info.DatasetInfo] = None"},{name:"features",val:": typing.Optional[datasets.features.features.Features] = None"},{name:"use_auth_token",val:": typing.Union[str, bool, NoneType] = None"},{name:"repo_id",val:": typing.Optional[str] = None"},{name:"data_files",val:": typing.Union[str, list, dict, datasets.data_files.DataFilesDict, NoneType] = None"},{name:"data_dir",val:": typing.Optional[str] = None"},{name:"name",val:" = 'deprecated'"},{name:"**config_kwargs",val:""}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/builder.py#L1619"}}),Vt=new j({props:{name:"class datasets.BuilderConfig",anchor:"datasets.BuilderConfig",parameters:[{name:"name",val:": str = 'default'"},{name:"version",val:": typing.Union[str, datasets.utils.version.Version, NoneType] = 0.0.0"},{name:"data_dir",val:": typing.Optional[str] = None"},{name:"data_files",val:": typing.Optional[datasets.data_files.DataFilesDict] = None"},{name:"description",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"datasets.BuilderConfig.name",description:"<strong>name</strong> (<code>str</code>, defaults to <code>default</code>) &#x2014;",name:"name"},{anchor:"datasets.BuilderConfig.version",description:"<strong>version</strong> (<code>Version</code> or <code>str</code>, <em>optional</em>) &#x2014;",name:"version"},{anchor:"datasets.BuilderConfig.data_dir",description:"<strong>data_dir</strong> (<code>str</code>, <em>optional</em>) &#x2014;",name:"data_dir"},{anchor:"datasets.BuilderConfig.data_files",description:`<strong>data_files</strong> (<code>str</code> or <code>Sequence</code> or <code>Mapping</code>, <em>optional</em>) &#x2014;
Path(s) to source data file(s).`,name:"data_files"},{anchor:"datasets.BuilderConfig.description",description:"<strong>description</strong> (<code>str</code>, <em>optional</em>) &#x2014;",name:"description"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/builder.py#L100"}}),zt=new j({props:{name:"create_config_id",anchor:"datasets.BuilderConfig.create_config_id",parameters:[{name:"config_kwargs",val:": dict"},{name:"custom_features",val:": typing.Optional[datasets.features.features.Features] = None"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/builder.py#L139"}}),Ft=new wr({}),Gt=new j({props:{name:"class datasets.DownloadManager",anchor:"datasets.DownloadManager",parameters:[{name:"dataset_name",val:": typing.Optional[str] = None"},{name:"data_dir",val:": typing.Optional[str] = None"},{name:"download_config",val:": typing.Optional[datasets.download.download_config.DownloadConfig] = None"},{name:"base_path",val:": typing.Optional[str] = None"},{name:"record_checksums",val:" = True"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/download_manager.py#L150"}}),Ht=new j({props:{name:"download",anchor:"datasets.DownloadManager.download",parameters:[{name:"url_or_urls",val:""}],parametersDescription:[{anchor:"datasets.DownloadManager.download.url_or_urls",description:`<strong>url_or_urls</strong> (<code>str</code> or <code>list</code> or <code>dict</code>) &#x2014;
URL or <code>list</code> or <code>dict</code> of URLs to download. Each URL is a <code>str</code>.`,name:"url_or_urls"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/download_manager.py#L304",returnDescription:`
<p>The downloaded paths matching the given input <code>url_or_urls</code>.</p>
`,returnType:`
<p><code>str</code> or <code>list</code> or <code>dict</code></p>
`}}),Ze=new T({props:{anchor:"datasets.DownloadManager.download.example",$$slots:{default:[hg]},$$scope:{ctx:k}}}),Xt=new j({props:{name:"download_and_extract",anchor:"datasets.DownloadManager.download_and_extract",parameters:[{name:"url_or_urls",val:""}],parametersDescription:[{anchor:"datasets.DownloadManager.download_and_extract.url_or_urls",description:`<strong>url_or_urls</strong> (<code>str</code> or <code>list</code> or <code>dict</code>) &#x2014;
URL or <code>list</code> or <code>dict</code> of URLs to download and extract. Each URL is a <code>str</code>.`,name:"url_or_urls"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/download_manager.py#L452",returnDescription:`
<p><code>str</code>, extracted paths of given URL(s).</p>
`,returnType:`
<p>extracted_path(s)</p>
`}}),et=new T({props:{anchor:"datasets.DownloadManager.download_and_extract.example",$$slots:{default:[$g]},$$scope:{ctx:k}}}),Jt=new j({props:{name:"download_custom",anchor:"datasets.DownloadManager.download_custom",parameters:[{name:"url_or_urls",val:""},{name:"custom_download",val:""}],parametersDescription:[{anchor:"datasets.DownloadManager.download_custom.url_or_urls",description:`<strong>url_or_urls</strong> (<code>str</code> or <code>list</code> or <code>dict</code>) &#x2014;
URL or <code>list</code> or <code>dict</code> of URLs to download and extract. Each URL is a <code>str</code>.`,name:"url_or_urls"},{anchor:"datasets.DownloadManager.download_custom.custom_download",description:`<strong>custom_download</strong> (<code>Callable[src_url, dst_path]</code>) &#x2014;
The source URL and destination path. For example
<code>tf.io.gfile.copy</code>, that lets you download from  Google storage.`,name:"custom_download"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/download_manager.py#L256",returnDescription:`
<p><code>str</code>, The downloaded paths matching the given input
<code>url_or_urls</code>.</p>
`,returnType:`
<p>downloaded_path(s)</p>
`}}),tt=new T({props:{anchor:"datasets.DownloadManager.download_custom.example",$$slots:{default:[bg]},$$scope:{ctx:k}}}),Qt=new j({props:{name:"extract",anchor:"datasets.DownloadManager.extract",parameters:[{name:"path_or_paths",val:""},{name:"num_proc",val:" = 'deprecated'"}],parametersDescription:[{anchor:"datasets.DownloadManager.extract.path_or_paths",description:`<strong>path_or_paths</strong> (path or <code>list</code> or <code>dict</code>) &#x2014;
Path of file to extract. Each path is a <code>str</code>.`,name:"path_or_paths"},{anchor:"datasets.DownloadManager.extract.num_proc",description:`<strong>num_proc</strong> (<code>int</code>) &#x2014;
Use multi-processing if <code>num_proc</code> &gt; 1 and the length of
<code>path_or_paths</code> is larger than <code>num_proc</code>.</p>
<div class="course-tip course-tip-orange bg-gradient-to-br dark:bg-gradient-to-r before:border-orange-500 dark:before:border-orange-800 from-orange-50 dark:from-gray-900 to-white dark:to-gray-950 border border-orange-50 text-orange-700 dark:text-gray-400">
						<p class="font-medium">Deprecated in 2.6.2</p>
						
<p>Pass <code>DownloadConfig(num_proc=&lt;num_proc&gt;)</code> to the initializer instead.</p>

					</div>`,name:"num_proc"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/download_manager.py#L403",returnDescription:`
<p><code>str</code>, The extracted paths matching the given input
path_or_paths.</p>
`,returnType:`
<p>extracted_path(s)</p>
`}}),at=new T({props:{anchor:"datasets.DownloadManager.extract.example",$$slots:{default:[vg]},$$scope:{ctx:k}}}),Zt=new j({props:{name:"iter_archive",anchor:"datasets.DownloadManager.iter_archive",parameters:[{name:"path_or_buf",val:": typing.Union[str, _io.BufferedReader]"}],parametersDescription:[{anchor:"datasets.DownloadManager.iter_archive.path_or_buf",description:`<strong>path_or_buf</strong> (<code>str</code> or <code>io.BufferedReader</code>) &#x2014;
Archive path or archive binary file object.`,name:"path_or_buf"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/download_manager.py#L359",returnType:`
<p><code>tuple[str, io.BufferedReader]</code></p>
`,isYield:!0}}),st=new T({props:{anchor:"datasets.DownloadManager.iter_archive.example",$$slots:{default:[wg]},$$scope:{ctx:k}}}),ea=new j({props:{name:"iter_files",anchor:"datasets.DownloadManager.iter_files",parameters:[{name:"paths",val:": typing.Union[str, typing.List[str]]"}],parametersDescription:[{anchor:"datasets.DownloadManager.iter_files.paths",description:`<strong>paths</strong> (<code>str</code> or <code>list</code> of <code>str</code>) &#x2014;
Root paths.`,name:"paths"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/download_manager.py#L384",returnType:`
<p><code>str</code></p>
`,isYield:!0}}),ot=new T({props:{anchor:"datasets.DownloadManager.iter_files.example",$$slots:{default:[xg]},$$scope:{ctx:k}}}),ta=new j({props:{name:"ship_files_with_pipeline",anchor:"datasets.DownloadManager.ship_files_with_pipeline",parameters:[{name:"downloaded_path_or_paths",val:""},{name:"pipeline",val:""}],parametersDescription:[{anchor:"datasets.DownloadManager.ship_files_with_pipeline.downloaded_path_or_paths",description:`<strong>downloaded_path_or_paths</strong> (<code>str</code> or <code>list[str]</code> or <code>dict[str, str]</code>) &#x2014;
Nested structure containing the
downloaded path(s).`,name:"downloaded_path_or_paths"},{anchor:"datasets.DownloadManager.ship_files_with_pipeline.pipeline",description:`<strong>pipeline</strong> (<code>utils.beam_utils.BeamPipeline</code>) &#x2014;
Apache Beam Pipeline.`,name:"pipeline"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/download_manager.py#L197",returnDescription:`
<p><code>str</code> or <code>list[str]</code> or <code>dict[str, str]</code></p>
`}}),aa=new j({props:{name:"class datasets.StreamingDownloadManager",anchor:"datasets.StreamingDownloadManager",parameters:[{name:"dataset_name",val:": typing.Optional[str] = None"},{name:"data_dir",val:": typing.Optional[str] = None"},{name:"download_config",val:": typing.Optional[datasets.download.download_config.DownloadConfig] = None"},{name:"base_path",val:": typing.Optional[str] = None"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/streaming_download_manager.py#L866"}}),sa=new j({props:{name:"download",anchor:"datasets.StreamingDownloadManager.download",parameters:[{name:"url_or_urls",val:""}],parametersDescription:[{anchor:"datasets.StreamingDownloadManager.download.url_or_urls",description:`<strong>url_or_urls</strong> (<code>str</code> or <code>list</code> or <code>dict</code>) &#x2014;
URL(s) of files to stream data from. Each url is a <code>str</code>.`,name:"url_or_urls"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/streaming_download_manager.py#L892",returnDescription:`
<p>(<code>str</code> or <code>list</code> or <code>dict</code>), URL(s) to stream data from matching the given input url_or_urls.</p>
`,returnType:`
<p>url(s)</p>
`}}),nt=new T({props:{anchor:"datasets.StreamingDownloadManager.download.example",$$slots:{default:[Dg]},$$scope:{ctx:k}}}),ra=new j({props:{name:"download_and_extract",anchor:"datasets.StreamingDownloadManager.download_and_extract",parameters:[{name:"url_or_urls",val:""}],parametersDescription:[{anchor:"datasets.StreamingDownloadManager.download_and_extract.url_or_urls",description:`<strong>url_or_urls</strong> (<code>str</code> or <code>list</code> or <code>dict</code>) &#x2014;
URL(s) to stream from data from. Each url is a <code>str</code>.`,name:"url_or_urls"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/streaming_download_manager.py#L955",returnDescription:`
<p>(<code>str</code> or <code>list</code> or <code>dict</code>), URL(s) to stream data from matching the given input <code>url_or_urls</code>.</p>
`,returnType:`
<p>url(s)</p>
`}}),dt=new T({props:{anchor:"datasets.StreamingDownloadManager.download_and_extract.example",$$slots:{default:[Eg]},$$scope:{ctx:k}}}),la=new j({props:{name:"extract",anchor:"datasets.StreamingDownloadManager.extract",parameters:[{name:"url_or_urls",val:""}],parametersDescription:[{anchor:"datasets.StreamingDownloadManager.extract.url_or_urls",description:`<strong>url_or_urls</strong> (<code>str</code> or <code>list</code> or <code>dict</code>) &#x2014;
URL(s) of files to stream data from. Each url is a <code>str</code>.`,name:"url_or_urls"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/streaming_download_manager.py#L919",returnDescription:`
<p>(<code>str</code> or <code>list</code> or <code>dict</code>), URL(s) to stream data from matching the given input <code>url_or_urls</code>.</p>
`,returnType:`
<p>url(s)</p>
`}}),lt=new T({props:{anchor:"datasets.StreamingDownloadManager.extract.example",$$slots:{default:[yg]},$$scope:{ctx:k}}}),ca=new j({props:{name:"iter_archive",anchor:"datasets.StreamingDownloadManager.iter_archive",parameters:[{name:"urlpath_or_buf",val:": typing.Union[str, _io.BufferedReader]"}],parametersDescription:[{anchor:"datasets.StreamingDownloadManager.iter_archive.urlpath_or_buf",description:`<strong>urlpath_or_buf</strong> (<code>str</code> or <code>io.BufferedReader</code>) &#x2014;
Archive path or archive binary file object.`,name:"urlpath_or_buf"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/streaming_download_manager.py#L975",returnType:`
<p><code>tuple[str, io.BufferedReader]</code></p>
`,isYield:!0}}),it=new T({props:{anchor:"datasets.StreamingDownloadManager.iter_archive.example",$$slots:{default:[kg]},$$scope:{ctx:k}}}),pa=new j({props:{name:"iter_files",anchor:"datasets.StreamingDownloadManager.iter_files",parameters:[{name:"urlpaths",val:": typing.Union[str, typing.List[str]]"}],parametersDescription:[{anchor:"datasets.StreamingDownloadManager.iter_files.urlpaths",description:`<strong>urlpaths</strong> (<code>str</code> or <code>list</code> of <code>str</code>) &#x2014;
Root paths.`,name:"urlpaths"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/streaming_download_manager.py#L1000",returnType:`
<p>str</p>
`,isYield:!0}}),ct=new T({props:{anchor:"datasets.StreamingDownloadManager.iter_files.example",$$slots:{default:[jg]},$$scope:{ctx:k}}}),ma=new j({props:{name:"class datasets.DownloadConfig",anchor:"datasets.DownloadConfig",parameters:[{name:"cache_dir",val:": typing.Union[str, pathlib.Path, NoneType] = None"},{name:"force_download",val:": bool = False"},{name:"resume_download",val:": bool = False"},{name:"local_files_only",val:": bool = False"},{name:"proxies",val:": typing.Optional[typing.Dict] = None"},{name:"user_agent",val:": typing.Optional[str] = None"},{name:"extract_compressed_file",val:": bool = False"},{name:"force_extract",val:": bool = False"},{name:"delete_extracted",val:": bool = False"},{name:"use_etag",val:": bool = True"},{name:"num_proc",val:": typing.Optional[int] = None"},{name:"max_retries",val:": int = 1"},{name:"use_auth_token",val:": typing.Union[bool, str, NoneType] = None"},{name:"ignore_url_params",val:": bool = False"},{name:"download_desc",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"datasets.DownloadConfig.cache_dir",description:`<strong>cache_dir</strong> (<code>str</code> or <code>Path</code>, <em>optional</em>) &#x2014;
Specify a cache directory to save the file to (overwrite the
default cache dir).`,name:"cache_dir"},{anchor:"datasets.DownloadConfig.force_download",description:`<strong>force_download</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
If <code>True</code>, re-dowload the file even if it&#x2019;s already cached in
the cache dir.`,name:"force_download"},{anchor:"datasets.DownloadConfig.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
If <code>True</code>, resume the download if incompletly recieved file is
found.`,name:"resume_download"},{anchor:"datasets.DownloadConfig.proxies",description:"<strong>proxies</strong> (<code>dict</code>, <em>optional</em>) &#x2014;",name:"proxies"},{anchor:"datasets.DownloadConfig.user_agent",description:`<strong>user_agent</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Optional string or dict that will be appended to the user-agent on remote
requests.`,name:"user_agent"},{anchor:"datasets.DownloadConfig.extract_compressed_file",description:`<strong>extract_compressed_file</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
If <code>True</code> and the path point to a zip or tar file,
extract the compressed file in a folder along the archive.`,name:"extract_compressed_file"},{anchor:"datasets.DownloadConfig.force_extract",description:`<strong>force_extract</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
If <code>True</code> when <code>extract_compressed_file</code> is <code>True</code> and the archive
was already extracted, re-extract the archive and override the folder where it was extracted.`,name:"force_extract"},{anchor:"datasets.DownloadConfig.delete_extracted",description:`<strong>delete_extracted</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to delete (or keep) the extracted files.`,name:"delete_extracted"},{anchor:"datasets.DownloadConfig.use_etag",description:`<strong>use_etag</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to use the ETag HTTP response header to validate the cached files.`,name:"use_etag"},{anchor:"datasets.DownloadConfig.num_proc",description:`<strong>num_proc</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The number of processes to launch to download the files in parallel.`,name:"num_proc"},{anchor:"datasets.DownloadConfig.max_retries",description:`<strong>max_retries</strong> (<code>int</code>, default to <code>1</code>) &#x2014;
The number of times to retry an HTTP request if it fails.`,name:"max_retries"},{anchor:"datasets.DownloadConfig.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <code>bool</code>, <em>optional</em>) &#x2014;
Optional string or boolean to use as Bearer token
for remote files on the Datasets Hub. If <code>True</code>, or not specified, will get token from <code>~/.huggingface</code>.`,name:"use_auth_token"},{anchor:"datasets.DownloadConfig.ignore_url_params",description:`<strong>ignore_url_params</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to strip all query parameters and fragments from
the download URL before using it for caching the file.`,name:"ignore_url_params"},{anchor:"datasets.DownloadConfig.download_desc",description:`<strong>download_desc</strong> (<code>str</code>, <em>optional</em>) &#x2014;
A description to be displayed alongside with the progress bar while downloading the files.`,name:"download_desc"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/download_config.py#L8"}}),ga=new j({props:{name:"class datasets.DownloadMode",anchor:"datasets.DownloadMode",parameters:[{name:"value",val:""},{name:"names",val:" = None"},{name:"module",val:" = None"},{name:"qualname",val:" = None"},{name:"type",val:" = None"},{name:"start",val:" = 1"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/download/download_manager.py#L41"}}),_a=new wr({}),ha=new j({props:{name:"class datasets.SplitGenerator",anchor:"datasets.SplitGenerator",parameters:[{name:"name",val:": str"},{name:"gen_kwargs",val:": typing.Dict = <factory>"}],parametersDescription:[{anchor:"datasets.SplitGenerator.name",description:`<strong>name</strong> (<code>str</code>) &#x2014;
Name of the <code>Split</code> for which the generator will
create the examples.`,name:"name"},{anchor:"datasets.SplitGenerator.*gen_kwargs",description:`*<strong>*gen_kwargs</strong> (additional keyword arguments) &#x2014;
Keyword arguments to forward to the <code>DatasetBuilder._generate_examples</code> method
of the builder.`,name:"*gen_kwargs"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/splits.py#L602"}}),mt=new T({props:{anchor:"datasets.SplitGenerator.example",$$slots:{default:[Tg]},$$scope:{ctx:k}}}),$a=new j({props:{name:"class datasets.Split",anchor:"datasets.Split",parameters:[{name:"name",val:""}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/splits.py#L405"}}),gt=new T({props:{anchor:"datasets.Split.example",$$slots:{default:[Sg]},$$scope:{ctx:k}}}),wa=new j({props:{name:"class datasets.NamedSplit",anchor:"datasets.NamedSplit",parameters:[{name:"name",val:""}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/splits.py#L313"}}),ft=new T({props:{anchor:"datasets.NamedSplit.example",$$slots:{default:[Ig]},$$scope:{ctx:k}}}),ut=new T({props:{anchor:"datasets.NamedSplit.example-2",$$slots:{default:[Bg]},$$scope:{ctx:k}}}),_t=new T({props:{anchor:"datasets.NamedSplit.example-3",$$slots:{default:[Ng]},$$scope:{ctx:k}}}),ht=new T({props:{anchor:"datasets.NamedSplit.example-4",$$slots:{default:[Pg]},$$scope:{ctx:k}}}),xa=new j({props:{name:"class datasets.NamedSplitAll",anchor:"datasets.NamedSplitAll",parameters:[],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/splits.py#L390"}}),Da=new j({props:{name:"class datasets.ReadInstruction",anchor:"datasets.ReadInstruction",parameters:[{name:"split_name",val:""},{name:"rounding",val:" = None"},{name:"from_",val:" = None"},{name:"to",val:" = None"},{name:"unit",val:" = None"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/arrow_reader.py#L484"}}),$t=new T({props:{anchor:"datasets.ReadInstruction.example",$$slots:{default:[Cg]},$$scope:{ctx:k}}}),Ea=new j({props:{name:"from_spec",anchor:"datasets.ReadInstruction.from_spec",parameters:[{name:"spec",val:""}],parametersDescription:[{anchor:"datasets.ReadInstruction.from_spec.spec",description:`<strong>spec</strong> (<code>str</code>) &#x2014;
Split(s) + optional slice(s) to read + optional rounding
if percents are used as the slicing unit. A slice can be specified,
using absolute numbers (<code>int</code>) or percentages (<code>int</code>).`,name:"spec"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/arrow_reader.py#L564",returnDescription:`
<p>ReadInstruction instance.</p>
`}}),bt=new T({props:{anchor:"datasets.ReadInstruction.from_spec.example",$$slots:{default:[Rg]},$$scope:{ctx:k}}}),ka=new j({props:{name:"to_absolute",anchor:"datasets.ReadInstruction.to_absolute",parameters:[{name:"name2len",val:""}],parametersDescription:[{anchor:"datasets.ReadInstruction.to_absolute.name2len",description:`<strong>name2len</strong> (<code>dict</code>) &#x2014;
Associating split names to number of examples.`,name:"name2len"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/arrow_reader.py#L636",returnDescription:`
<p>list of _AbsoluteInstruction instances (corresponds to the + in spec).</p>
`}}),ja=new wr({}),Ta=new j({props:{name:"class datasets.Version",anchor:"datasets.Version",parameters:[{name:"version_str",val:": str"},{name:"description",val:": typing.Optional[str] = None"},{name:"major",val:": typing.Union[str, int, NoneType] = None"},{name:"minor",val:": typing.Union[str, int, NoneType] = None"},{name:"patch",val:": typing.Union[str, int, NoneType] = None"}],parametersDescription:[{anchor:"datasets.Version.version_str",description:`<strong>version_str</strong> (<code>str</code>) &#x2014;
The dataset version.`,name:"version_str"},{anchor:"datasets.Version.description",description:`<strong>description</strong> (<code>str</code>) &#x2014;
A description of what is new in this version.`,name:"description"},{anchor:"datasets.Version.major",description:"<strong>major</strong> (<code>str</code>) &#x2014;",name:"major"},{anchor:"datasets.Version.minor",description:"<strong>minor</strong> (<code>str</code>) &#x2014;",name:"minor"},{anchor:"datasets.Version.patch",description:"<strong>patch</strong> (<code>str</code>) &#x2014;",name:"patch"}],source:"https://github.com/huggingface/datasets/blob/main/src/datasets/utils/version.py#L30"}}),wt=new T({props:{anchor:"datasets.Version.example",$$slots:{default:[Lg]},$$scope:{ctx:k}}}),{c(){l=o("meta"),_=m(),f=o("h1"),n=o("a"),u=o("span"),b(t.$$.fragment),i=m(),de=o("span"),R=c("Builder classes"),H=m(),K=o("h2"),Ue=o("a"),ws=o("span"),b(It.$$.fragment),fn=m(),xs=o("span"),un=c("Builders"),xr=m(),le=o("p"),_n=c("\u{1F917} Datasets relies on two main classes during the dataset building process: "),Pa=o("a"),hn=c("DatasetBuilder"),$n=c(" and "),Ca=o("a"),bn=c("BuilderConfig"),vn=c("."),Dr=m(),B=o("div"),b(Bt.$$.fragment),wn=m(),Ds=o("p"),xn=c("Abstract base class for all datasets."),Dn=m(),Ra=o("p"),Es=o("code"),En=c("DatasetBuilder"),yn=c(" has 3 key methods:"),kn=m(),ye=o("ul"),La=o("li"),ys=o("code"),jn=c("DatasetBuilder.info"),Tn=c(`: Documents the dataset, including feature
names, types, shapes, version, splits, citation, etc.`),Sn=m(),Aa=o("li"),Oa=o("a"),In=c("DatasetBuilder.download_and_prepare()"),Bn=c(`: Downloads the source data
and writes it to disk.`),Nn=m(),ze=o("li"),qa=o("a"),Pn=c("DatasetBuilder.as_dataset()"),Cn=c(": Generates a "),Ma=o("a"),Rn=c("Dataset"),Ln=c("."),An=m(),ae=o("p"),On=c("Some "),ks=o("code"),qn=c("DatasetBuilder"),Mn=c(`s expose multiple variants of the
dataset by defining a `),Va=o("a"),Vn=c("BuilderConfig"),Un=c(` subclass and accepting a
config object (or name) on construction. Configurable datasets expose a
pre-defined set of configurations in `),js=o("code"),zn=c("DatasetBuilder.builder_configs()"),Fn=c("."),Gn=m(),ie=o("div"),b(Nt.$$.fragment),Hn=m(),Ts=o("p"),Wn=c("Return a Dataset for the specified split."),Xn=m(),b(Fe.$$.fragment),Kn=m(),O=o("div"),b(Pt.$$.fragment),Jn=m(),Ss=o("p"),Yn=c("Downloads and prepares dataset for reading."),Qn=m(),Is=o("p"),Zn=c("Example:"),ed=m(),b(Ge.$$.fragment),td=m(),b(He.$$.fragment),ad=m(),b(We.$$.fragment),sd=m(),ce=o("div"),b(Ct.$$.fragment),od=m(),Bs=o("p"),rd=c("Empty dict if doesn\u2019t exist"),nd=m(),b(Xe.$$.fragment),dd=m(),pe=o("div"),b(Rt.$$.fragment),ld=m(),Lt=o("p"),id=c("Empty "),Ns=o("code"),cd=c("DatasetInfo"),pd=c(" if doesn\u2019t exist"),md=m(),b(Ke.$$.fragment),gd=m(),Je=o("div"),b(At.$$.fragment),fd=m(),Ps=o("p"),ud=c("Return the path of the module of this class or subclass."),Er=m(),se=o("div"),b(Ot.$$.fragment),_d=m(),Cs=o("p"),hd=c("Base class for datasets with data generation based on dict generators."),$d=m(),me=o("p"),Rs=o("code"),bd=c("GeneratorBasedBuilder"),vd=c(` is a convenience class that abstracts away much
of the data writing and reading of `),Ls=o("code"),wd=c("DatasetBuilder"),xd=c(`. It expects subclasses to
implement generators of feature dictionaries across the dataset splits
(`),As=o("code"),Dd=c("_split_generators"),Ed=c("). See the method docstrings for details."),yr=m(),ke=o("div"),b(qt.$$.fragment),yd=m(),Os=o("p"),kd=c("Beam-based Builder."),kr=m(),je=o("div"),b(Mt.$$.fragment),jd=m(),qs=o("p"),Td=c("Base class for datasets with data generation based on Arrow loading functions (CSV/JSON/Parquet)."),jr=m(),W=o("div"),b(Vt.$$.fragment),Sd=m(),Ut=o("p"),Id=c("Base class for "),Ms=o("code"),Bd=c("DatasetBuilder"),Nd=c(" data configuration."),Pd=m(),Ye=o("p"),Vs=o("code"),Cd=c("DatasetBuilder"),Rd=c(` subclasses with data configuration options should subclass
`),Us=o("code"),Ld=c("BuilderConfig"),Ad=c(" and add their own properties."),Od=m(),J=o("div"),b(zt.$$.fragment),qd=m(),zs=o("p"),Md=c(`The config id is used to build the cache directory.
By default it is equal to the config name.
However the name of a config is not sufficient to have a unique identifier for the dataset being generated
since it doesn\u2019t take into account:`),Vd=m(),Te=o("ul"),Fs=o("li"),Ud=c("the config kwargs that can be used to overwrite attributes"),zd=m(),Gs=o("li"),Fd=c("the custom features used to write the dataset"),Gd=m(),Hs=o("li"),Hd=c("the data_files for json/text/csv/pandas datasets"),Wd=m(),Ws=o("p"),Xd=c("Therefore the config id is just the config name with an optional suffix based on these."),Tr=m(),Se=o("h2"),Qe=o("a"),Xs=o("span"),b(Ft.$$.fragment),Kd=m(),Ks=o("span"),Jd=c("Download"),Sr=m(),P=o("div"),b(Gt.$$.fragment),Yd=m(),Y=o("div"),b(Ht.$$.fragment),Qd=m(),Js=o("p"),Zd=c("Download given URL(s)."),el=m(),Wt=o("p"),tl=c("By default, only one process is used for download. Pass customized "),Ys=o("code"),al=c("download_config.num_proc"),sl=c(" to change this behavior."),ol=m(),b(Ze.$$.fragment),rl=m(),ge=o("div"),b(Xt.$$.fragment),nl=m(),Kt=o("p"),dl=c("Download and extract given "),Qs=o("code"),ll=c("url_or_urls"),il=c("."),cl=m(),b(et.$$.fragment),pl=m(),fe=o("div"),b(Jt.$$.fragment),ml=m(),Yt=o("p"),gl=c("Download given urls(s) by calling "),Zs=o("code"),fl=c("custom_download"),ul=c("."),_l=m(),b(tt.$$.fragment),hl=m(),ue=o("div"),b(Qt.$$.fragment),$l=m(),eo=o("p"),bl=c("Extract given path(s)."),vl=m(),b(at.$$.fragment),wl=m(),_e=o("div"),b(Zt.$$.fragment),xl=m(),to=o("p"),Dl=c("Iterate over files within an archive."),El=m(),b(st.$$.fragment),yl=m(),he=o("div"),b(ea.$$.fragment),kl=m(),ao=o("p"),jl=c("Iterate over file paths."),Tl=m(),b(ot.$$.fragment),Sl=m(),rt=o("div"),b(ta.$$.fragment),Il=m(),so=o("p"),Bl=c("Ship the files using Beam FileSystems to the pipeline temp dir."),Ir=m(),L=o("div"),b(aa.$$.fragment),Nl=m(),V=o("p"),Pl=c(`Download manager that uses the \u201D::\u201D separator to navigate through (possibly remote) compressed archives.
Contrary to the regular `),oo=o("code"),Cl=c("DownloadManager"),Rl=c(", the "),ro=o("code"),Ll=c("download"),Al=c(" and "),no=o("code"),Ol=c("extract"),ql=c(` methods don\u2019t actually download nor extract
data, but they rather return the path or url that could be opened using the `),lo=o("code"),Ml=c("xopen"),Vl=c(` function which extends the
built-in `),io=o("code"),Ul=c("open"),zl=c(" function to stream data from remote files."),Fl=m(),$e=o("div"),b(sa.$$.fragment),Gl=m(),oa=o("p"),Hl=c(`Normalize URL(s) of files to stream data from.
This is the lazy version of `),co=o("code"),Wl=c("DownloadManager.download"),Xl=c(" for streaming."),Kl=m(),b(nt.$$.fragment),Jl=m(),Q=o("div"),b(ra.$$.fragment),Yl=m(),na=o("p"),Ql=c("Prepare given "),po=o("code"),Zl=c("url_or_urls"),ei=c(" for streaming (add extraction protocol)."),ti=m(),da=o("p"),ai=c("This is the lazy version of "),mo=o("code"),si=c("DownloadManager.download_and_extract"),oi=c(" for streaming."),ri=m(),b(dt.$$.fragment),ni=m(),Z=o("div"),b(la.$$.fragment),di=m(),go=o("p"),li=c("Add extraction protocol for given url(s) for streaming."),ii=m(),ia=o("p"),ci=c("This is the lazy version of "),fo=o("code"),pi=c("DownloadManager.extract"),mi=c(" for streaming."),gi=m(),b(lt.$$.fragment),fi=m(),be=o("div"),b(ca.$$.fragment),ui=m(),uo=o("p"),_i=c("Iterate over files within an archive."),hi=m(),b(it.$$.fragment),$i=m(),ve=o("div"),b(pa.$$.fragment),bi=m(),_o=o("p"),vi=c("Iterate over files."),wi=m(),b(ct.$$.fragment),Br=m(),Ie=o("div"),b(ma.$$.fragment),xi=m(),ho=o("p"),Di=c("Configuration for our cached path manager."),Nr=m(),U=o("div"),b(ga.$$.fragment),Ei=m(),Ua=o("p"),$o=o("code"),yi=c("Enum"),ki=c(" for how to treat pre-existing downloads and data."),ji=m(),fa=o("p"),Ti=c("The default mode is "),bo=o("code"),Si=c("REUSE_DATASET_IF_EXISTS"),Ii=c(`, which will reuse both
raw downloads and the prepared dataset if they exist.`),Bi=m(),vo=o("p"),Ni=c("The generations modes:"),Pi=m(),ua=o("table"),wo=o("thead"),Be=o("tr"),Pr=o("th"),Ci=m(),xo=o("th"),Ri=c("Downloads"),Li=m(),Do=o("th"),Ai=c("Dataset"),Oi=m(),Ne=o("tbody"),Pe=o("tr"),za=o("td"),Eo=o("code"),qi=c("REUSE_DATASET_IF_EXISTS"),Mi=c(" (default)"),Vi=m(),yo=o("td"),Ui=c("Reuse"),zi=m(),ko=o("td"),Fi=c("Reuse"),Gi=m(),Ce=o("tr"),jo=o("td"),To=o("code"),Hi=c("REUSE_CACHE_IF_EXISTS"),Wi=m(),So=o("td"),Xi=c("Reuse"),Ki=m(),Io=o("td"),Ji=c("Fresh"),Yi=m(),Re=o("tr"),Bo=o("td"),No=o("code"),Qi=c("FORCE_REDOWNLOAD"),Zi=m(),Po=o("td"),ec=c("Fresh"),tc=m(),Co=o("td"),ac=c("Fresh"),Cr=m(),Le=o("h2"),pt=o("a"),Ro=o("span"),b(_a.$$.fragment),sc=m(),Lo=o("span"),oc=c("Splits"),Rr=m(),X=o("div"),b(ha.$$.fragment),rc=m(),Ao=o("p"),nc=c("Defines the split information for the generator."),dc=m(),Ae=o("p"),lc=c(`This should be used as returned value of
`),Oo=o("code"),ic=c("GeneratorBasedBuilder._split_generators"),cc=c(`.
See `),qo=o("code"),pc=c("GeneratorBasedBuilder._split_generators"),mc=c(` for more info and example
of usage.`),gc=m(),b(mt.$$.fragment),Lr=m(),A=o("div"),b($a.$$.fragment),fc=m(),Fa=o("p"),Mo=o("code"),uc=c("Enum"),_c=c(" for dataset splits."),hc=m(),Vo=o("p"),$c=c(`Datasets are typically split into different subsets to be used at various
stages of training and evaluation.`),bc=m(),oe=o("ul"),Ga=o("li"),Uo=o("code"),vc=c("TRAIN"),wc=c(": the training data."),xc=m(),Ha=o("li"),zo=o("code"),Dc=c("VALIDATION"),Ec=c(`: the validation data. If present, this is typically used as
evaluation data while iterating on a model (e.g. changing hyperparameters,
model architecture, etc.).`),yc=m(),Wa=o("li"),Fo=o("code"),kc=c("TEST"),jc=c(`: the testing data. This is the data to report metrics on. Typically
you do not want to use this during model iteration as you may overfit to it.`),Tc=m(),Xa=o("li"),Go=o("code"),Sc=c("ALL"),Ic=c(": the union of all defined dataset splits."),Bc=m(),ba=o("p"),Nc=c("All splits, including compositions inherit from "),Ho=o("code"),Pc=c("datasets.SplitBase"),Cc=c("."),Rc=m(),va=o("p"),Lc=c("See the "),Ka=o("a"),Ac=c("guide"),Oc=c(" on splits for more information."),qc=m(),b(gt.$$.fragment),Ar=m(),C=o("div"),b(wa.$$.fragment),Mc=m(),Wo=o("p"),Vc=c("Descriptor corresponding to a named split (train, test, \u2026)."),Uc=m(),Xo=o("p"),zc=c("Example:"),Fc=m(),b(ft.$$.fragment),Gc=m(),Ko=o("p"),Hc=c(`The resulting split will correspond to 25% of the train split merged with
100% of the test split.`),Wc=m(),b(ut.$$.fragment),Xc=m(),b(_t.$$.fragment),Kc=m(),b(ht.$$.fragment),Or=m(),Oe=o("div"),b(xa.$$.fragment),Jc=m(),Jo=o("p"),Yc=c("Split corresponding to the union of all defined dataset splits."),qr=m(),z=o("div"),b(Da.$$.fragment),Qc=m(),Yo=o("p"),Zc=c("Reading instruction for a dataset."),ep=m(),b($t.$$.fragment),tp=m(),we=o("div"),b(Ea.$$.fragment),ap=m(),ya=o("p"),sp=c("Creates a "),Qo=o("code"),op=c("ReadInstruction"),rp=c(" instance out of a string spec."),np=m(),b(bt.$$.fragment),dp=m(),xe=o("div"),b(ka.$$.fragment),lp=m(),Zo=o("p"),ip=c("Translate instruction into a list of absolute instructions."),cp=m(),er=o("p"),pp=c("Those absolute instructions are then to be added together."),Mr=m(),qe=o("h2"),vt=o("a"),tr=o("span"),b(ja.$$.fragment),mp=m(),ar=o("span"),gp=c("Version"),Vr=m(),re=o("div"),b(Ta.$$.fragment),fp=m(),Sa=o("p"),up=c("Dataset version "),sr=o("code"),_p=c("MAJOR.MINOR.PATCH"),hp=c("."),$p=m(),b(wt.$$.fragment),this.h()},l(s){const h=ig('[data-svelte="svelte-1phssyn"]',document.head);l=r(h,"META",{name:!0,content:!0}),h.forEach(a),_=g(s),f=r(s,"H1",{class:!0});var Ia=d(f);n=r(Ia,"A",{id:!0,class:!0,href:!0});var or=d(n);u=r(or,"SPAN",{});var rr=d(u);v(t.$$.fragment,rr),rr.forEach(a),or.forEach(a),i=g(Ia),de=r(Ia,"SPAN",{});var nr=d(de);R=p(nr,"Builder classes"),nr.forEach(a),Ia.forEach(a),H=g(s),K=r(s,"H2",{class:!0});var Ba=d(K);Ue=r(Ba,"A",{id:!0,class:!0,href:!0});var dr=d(Ue);ws=r(dr,"SPAN",{});var lr=d(ws);v(It.$$.fragment,lr),lr.forEach(a),dr.forEach(a),fn=g(Ba),xs=r(Ba,"SPAN",{});var ir=d(xs);un=p(ir,"Builders"),ir.forEach(a),Ba.forEach(a),xr=g(s),le=r(s,"P",{});var Me=d(le);_n=p(Me,"\u{1F917} Datasets relies on two main classes during the dataset building process: "),Pa=r(Me,"A",{href:!0});var cr=d(Pa);hn=p(cr,"DatasetBuilder"),cr.forEach(a),$n=p(Me," and "),Ca=r(Me,"A",{href:!0});var pr=d(Ca);bn=p(pr,"BuilderConfig"),pr.forEach(a),vn=p(Me,"."),Me.forEach(a),Dr=g(s),B=r(s,"DIV",{class:!0});var N=d(B);v(Bt.$$.fragment,N),wn=g(N),Ds=r(N,"P",{});var mr=d(Ds);xn=p(mr,"Abstract base class for all datasets."),mr.forEach(a),Dn=g(N),Ra=r(N,"P",{});var Ja=d(Ra);Es=r(Ja,"CODE",{});var gr=d(Es);En=p(gr,"DatasetBuilder"),gr.forEach(a),yn=p(Ja," has 3 key methods:"),Ja.forEach(a),kn=g(N),ye=r(N,"UL",{});var Ve=d(ye);La=r(Ve,"LI",{});var Ya=d(La);ys=r(Ya,"CODE",{});var fr=d(ys);jn=p(fr,"DatasetBuilder.info"),fr.forEach(a),Tn=p(Ya,`: Documents the dataset, including feature
names, types, shapes, version, splits, citation, etc.`),Ya.forEach(a),Sn=g(Ve),Aa=r(Ve,"LI",{});var Qa=d(Aa);Oa=r(Qa,"A",{href:!0});var ur=d(Oa);In=p(ur,"DatasetBuilder.download_and_prepare()"),ur.forEach(a),Bn=p(Qa,`: Downloads the source data
and writes it to disk.`),Qa.forEach(a),Nn=g(Ve),ze=r(Ve,"LI",{});var xt=d(ze);qa=r(xt,"A",{href:!0});var _r=d(qa);Pn=p(_r,"DatasetBuilder.as_dataset()"),_r.forEach(a),Cn=p(xt,": Generates a "),Ma=r(xt,"A",{href:!0});var hr=d(Ma);Rn=p(hr,"Dataset"),hr.forEach(a),Ln=p(xt,"."),xt.forEach(a),Ve.forEach(a),An=g(N),ae=r(N,"P",{});var ne=d(ae);On=p(ne,"Some "),ks=r(ne,"CODE",{});var $r=d(ks);qn=p($r,"DatasetBuilder"),$r.forEach(a),Mn=p(ne,`s expose multiple variants of the
dataset by defining a `),Va=r(ne,"A",{href:!0});var br=d(Va);Vn=p(br,"BuilderConfig"),br.forEach(a),Un=p(ne,` subclass and accepting a
config object (or name) on construction. Configurable datasets expose a
pre-defined set of configurations in `),js=r(ne,"CODE",{});var kp=d(js);zn=p(kp,"DatasetBuilder.builder_configs()"),kp.forEach(a),Fn=p(ne,"."),ne.forEach(a),Gn=g(N),ie=r(N,"DIV",{class:!0});var Za=d(ie);v(Nt.$$.fragment,Za),Hn=g(Za),Ts=r(Za,"P",{});var jp=d(Ts);Wn=p(jp,"Return a Dataset for the specified split."),jp.forEach(a),Xn=g(Za),v(Fe.$$.fragment,Za),Za.forEach(a),Kn=g(N),O=r(N,"DIV",{class:!0});var ee=d(O);v(Pt.$$.fragment,ee),Jn=g(ee),Ss=r(ee,"P",{});var Tp=d(Ss);Yn=p(Tp,"Downloads and prepares dataset for reading."),Tp.forEach(a),Qn=g(ee),Is=r(ee,"P",{});var Sp=d(Is);Zn=p(Sp,"Example:"),Sp.forEach(a),ed=g(ee),v(Ge.$$.fragment,ee),td=g(ee),v(He.$$.fragment,ee),ad=g(ee),v(We.$$.fragment,ee),ee.forEach(a),sd=g(N),ce=r(N,"DIV",{class:!0});var es=d(ce);v(Ct.$$.fragment,es),od=g(es),Bs=r(es,"P",{});var Ip=d(Bs);rd=p(Ip,"Empty dict if doesn\u2019t exist"),Ip.forEach(a),nd=g(es),v(Xe.$$.fragment,es),es.forEach(a),dd=g(N),pe=r(N,"DIV",{class:!0});var ts=d(pe);v(Rt.$$.fragment,ts),ld=g(ts),Lt=r(ts,"P",{});var zr=d(Lt);id=p(zr,"Empty "),Ns=r(zr,"CODE",{});var Bp=d(Ns);cd=p(Bp,"DatasetInfo"),Bp.forEach(a),pd=p(zr," if doesn\u2019t exist"),zr.forEach(a),md=g(ts),v(Ke.$$.fragment,ts),ts.forEach(a),gd=g(N),Je=r(N,"DIV",{class:!0});var Fr=d(Je);v(At.$$.fragment,Fr),fd=g(Fr),Ps=r(Fr,"P",{});var Np=d(Ps);ud=p(Np,"Return the path of the module of this class or subclass."),Np.forEach(a),Fr.forEach(a),N.forEach(a),Er=g(s),se=r(s,"DIV",{class:!0});var as=d(se);v(Ot.$$.fragment,as),_d=g(as),Cs=r(as,"P",{});var Pp=d(Cs);hd=p(Pp,"Base class for datasets with data generation based on dict generators."),Pp.forEach(a),$d=g(as),me=r(as,"P",{});var Na=d(me);Rs=r(Na,"CODE",{});var Cp=d(Rs);bd=p(Cp,"GeneratorBasedBuilder"),Cp.forEach(a),vd=p(Na,` is a convenience class that abstracts away much
of the data writing and reading of `),Ls=r(Na,"CODE",{});var Rp=d(Ls);wd=p(Rp,"DatasetBuilder"),Rp.forEach(a),xd=p(Na,`. It expects subclasses to
implement generators of feature dictionaries across the dataset splits
(`),As=r(Na,"CODE",{});var Lp=d(As);Dd=p(Lp,"_split_generators"),Lp.forEach(a),Ed=p(Na,"). See the method docstrings for details."),Na.forEach(a),as.forEach(a),yr=g(s),ke=r(s,"DIV",{class:!0});var Gr=d(ke);v(qt.$$.fragment,Gr),yd=g(Gr),Os=r(Gr,"P",{});var Ap=d(Os);kd=p(Ap,"Beam-based Builder."),Ap.forEach(a),Gr.forEach(a),kr=g(s),je=r(s,"DIV",{class:!0});var Hr=d(je);v(Mt.$$.fragment,Hr),jd=g(Hr),qs=r(Hr,"P",{});var Op=d(qs);Td=p(Op,"Base class for datasets with data generation based on Arrow loading functions (CSV/JSON/Parquet)."),Op.forEach(a),Hr.forEach(a),jr=g(s),W=r(s,"DIV",{class:!0});var Dt=d(W);v(Vt.$$.fragment,Dt),Sd=g(Dt),Ut=r(Dt,"P",{});var Wr=d(Ut);Id=p(Wr,"Base class for "),Ms=r(Wr,"CODE",{});var qp=d(Ms);Bd=p(qp,"DatasetBuilder"),qp.forEach(a),Nd=p(Wr," data configuration."),Wr.forEach(a),Pd=g(Dt),Ye=r(Dt,"P",{});var vr=d(Ye);Vs=r(vr,"CODE",{});var Mp=d(Vs);Cd=p(Mp,"DatasetBuilder"),Mp.forEach(a),Rd=p(vr,` subclasses with data configuration options should subclass
`),Us=r(vr,"CODE",{});var Vp=d(Us);Ld=p(Vp,"BuilderConfig"),Vp.forEach(a),Ad=p(vr," and add their own properties."),vr.forEach(a),Od=g(Dt),J=r(Dt,"DIV",{class:!0});var Et=d(J);v(zt.$$.fragment,Et),qd=g(Et),zs=r(Et,"P",{});var Up=d(zs);Md=p(Up,`The config id is used to build the cache directory.
By default it is equal to the config name.
However the name of a config is not sufficient to have a unique identifier for the dataset being generated
since it doesn\u2019t take into account:`),Up.forEach(a),Vd=g(Et),Te=r(Et,"UL",{});var ss=d(Te);Fs=r(ss,"LI",{});var zp=d(Fs);Ud=p(zp,"the config kwargs that can be used to overwrite attributes"),zp.forEach(a),zd=g(ss),Gs=r(ss,"LI",{});var Fp=d(Gs);Fd=p(Fp,"the custom features used to write the dataset"),Fp.forEach(a),Gd=g(ss),Hs=r(ss,"LI",{});var Gp=d(Hs);Hd=p(Gp,"the data_files for json/text/csv/pandas datasets"),Gp.forEach(a),ss.forEach(a),Wd=g(Et),Ws=r(Et,"P",{});var Hp=d(Ws);Xd=p(Hp,"Therefore the config id is just the config name with an optional suffix based on these."),Hp.forEach(a),Et.forEach(a),Dt.forEach(a),Tr=g(s),Se=r(s,"H2",{class:!0});var Xr=d(Se);Qe=r(Xr,"A",{id:!0,class:!0,href:!0});var Wp=d(Qe);Xs=r(Wp,"SPAN",{});var Xp=d(Xs);v(Ft.$$.fragment,Xp),Xp.forEach(a),Wp.forEach(a),Kd=g(Xr),Ks=r(Xr,"SPAN",{});var Kp=d(Ks);Jd=p(Kp,"Download"),Kp.forEach(a),Xr.forEach(a),Sr=g(s),P=r(s,"DIV",{class:!0});var q=d(P);v(Gt.$$.fragment,q),Yd=g(q),Y=r(q,"DIV",{class:!0});var yt=d(Y);v(Ht.$$.fragment,yt),Qd=g(yt),Js=r(yt,"P",{});var Jp=d(Js);Zd=p(Jp,"Download given URL(s)."),Jp.forEach(a),el=g(yt),Wt=r(yt,"P",{});var Kr=d(Wt);tl=p(Kr,"By default, only one process is used for download. Pass customized "),Ys=r(Kr,"CODE",{});var Yp=d(Ys);al=p(Yp,"download_config.num_proc"),Yp.forEach(a),sl=p(Kr," to change this behavior."),Kr.forEach(a),ol=g(yt),v(Ze.$$.fragment,yt),yt.forEach(a),rl=g(q),ge=r(q,"DIV",{class:!0});var os=d(ge);v(Xt.$$.fragment,os),nl=g(os),Kt=r(os,"P",{});var Jr=d(Kt);dl=p(Jr,"Download and extract given "),Qs=r(Jr,"CODE",{});var Qp=d(Qs);ll=p(Qp,"url_or_urls"),Qp.forEach(a),il=p(Jr,"."),Jr.forEach(a),cl=g(os),v(et.$$.fragment,os),os.forEach(a),pl=g(q),fe=r(q,"DIV",{class:!0});var rs=d(fe);v(Jt.$$.fragment,rs),ml=g(rs),Yt=r(rs,"P",{});var Yr=d(Yt);gl=p(Yr,"Download given urls(s) by calling "),Zs=r(Yr,"CODE",{});var Zp=d(Zs);fl=p(Zp,"custom_download"),Zp.forEach(a),ul=p(Yr,"."),Yr.forEach(a),_l=g(rs),v(tt.$$.fragment,rs),rs.forEach(a),hl=g(q),ue=r(q,"DIV",{class:!0});var ns=d(ue);v(Qt.$$.fragment,ns),$l=g(ns),eo=r(ns,"P",{});var em=d(eo);bl=p(em,"Extract given path(s)."),em.forEach(a),vl=g(ns),v(at.$$.fragment,ns),ns.forEach(a),wl=g(q),_e=r(q,"DIV",{class:!0});var ds=d(_e);v(Zt.$$.fragment,ds),xl=g(ds),to=r(ds,"P",{});var tm=d(to);Dl=p(tm,"Iterate over files within an archive."),tm.forEach(a),El=g(ds),v(st.$$.fragment,ds),ds.forEach(a),yl=g(q),he=r(q,"DIV",{class:!0});var ls=d(he);v(ea.$$.fragment,ls),kl=g(ls),ao=r(ls,"P",{});var am=d(ao);jl=p(am,"Iterate over file paths."),am.forEach(a),Tl=g(ls),v(ot.$$.fragment,ls),ls.forEach(a),Sl=g(q),rt=r(q,"DIV",{class:!0});var Qr=d(rt);v(ta.$$.fragment,Qr),Il=g(Qr),so=r(Qr,"P",{});var sm=d(so);Bl=p(sm,"Ship the files using Beam FileSystems to the pipeline temp dir."),sm.forEach(a),Qr.forEach(a),q.forEach(a),Ir=g(s),L=r(s,"DIV",{class:!0});var F=d(L);v(aa.$$.fragment,F),Nl=g(F),V=r(F,"P",{});var te=d(V);Pl=p(te,`Download manager that uses the \u201D::\u201D separator to navigate through (possibly remote) compressed archives.
Contrary to the regular `),oo=r(te,"CODE",{});var om=d(oo);Cl=p(om,"DownloadManager"),om.forEach(a),Rl=p(te,", the "),ro=r(te,"CODE",{});var rm=d(ro);Ll=p(rm,"download"),rm.forEach(a),Al=p(te," and "),no=r(te,"CODE",{});var nm=d(no);Ol=p(nm,"extract"),nm.forEach(a),ql=p(te,` methods don\u2019t actually download nor extract
data, but they rather return the path or url that could be opened using the `),lo=r(te,"CODE",{});var dm=d(lo);Ml=p(dm,"xopen"),dm.forEach(a),Vl=p(te,` function which extends the
built-in `),io=r(te,"CODE",{});var lm=d(io);Ul=p(lm,"open"),lm.forEach(a),zl=p(te," function to stream data from remote files."),te.forEach(a),Fl=g(F),$e=r(F,"DIV",{class:!0});var is=d($e);v(sa.$$.fragment,is),Gl=g(is),oa=r(is,"P",{});var Zr=d(oa);Hl=p(Zr,`Normalize URL(s) of files to stream data from.
This is the lazy version of `),co=r(Zr,"CODE",{});var im=d(co);Wl=p(im,"DownloadManager.download"),im.forEach(a),Xl=p(Zr," for streaming."),Zr.forEach(a),Kl=g(is),v(nt.$$.fragment,is),is.forEach(a),Jl=g(F),Q=r(F,"DIV",{class:!0});var kt=d(Q);v(ra.$$.fragment,kt),Yl=g(kt),na=r(kt,"P",{});var en=d(na);Ql=p(en,"Prepare given "),po=r(en,"CODE",{});var cm=d(po);Zl=p(cm,"url_or_urls"),cm.forEach(a),ei=p(en," for streaming (add extraction protocol)."),en.forEach(a),ti=g(kt),da=r(kt,"P",{});var tn=d(da);ai=p(tn,"This is the lazy version of "),mo=r(tn,"CODE",{});var pm=d(mo);si=p(pm,"DownloadManager.download_and_extract"),pm.forEach(a),oi=p(tn," for streaming."),tn.forEach(a),ri=g(kt),v(dt.$$.fragment,kt),kt.forEach(a),ni=g(F),Z=r(F,"DIV",{class:!0});var jt=d(Z);v(la.$$.fragment,jt),di=g(jt),go=r(jt,"P",{});var mm=d(go);li=p(mm,"Add extraction protocol for given url(s) for streaming."),mm.forEach(a),ii=g(jt),ia=r(jt,"P",{});var an=d(ia);ci=p(an,"This is the lazy version of "),fo=r(an,"CODE",{});var gm=d(fo);pi=p(gm,"DownloadManager.extract"),gm.forEach(a),mi=p(an," for streaming."),an.forEach(a),gi=g(jt),v(lt.$$.fragment,jt),jt.forEach(a),fi=g(F),be=r(F,"DIV",{class:!0});var cs=d(be);v(ca.$$.fragment,cs),ui=g(cs),uo=r(cs,"P",{});var fm=d(uo);_i=p(fm,"Iterate over files within an archive."),fm.forEach(a),hi=g(cs),v(it.$$.fragment,cs),cs.forEach(a),$i=g(F),ve=r(F,"DIV",{class:!0});var ps=d(ve);v(pa.$$.fragment,ps),bi=g(ps),_o=r(ps,"P",{});var um=d(_o);vi=p(um,"Iterate over files."),um.forEach(a),wi=g(ps),v(ct.$$.fragment,ps),ps.forEach(a),F.forEach(a),Br=g(s),Ie=r(s,"DIV",{class:!0});var sn=d(Ie);v(ma.$$.fragment,sn),xi=g(sn),ho=r(sn,"P",{});var _m=d(ho);Di=p(_m,"Configuration for our cached path manager."),_m.forEach(a),sn.forEach(a),Nr=g(s),U=r(s,"DIV",{class:!0});var De=d(U);v(ga.$$.fragment,De),Ei=g(De),Ua=r(De,"P",{});var bp=d(Ua);$o=r(bp,"CODE",{});var hm=d($o);yi=p(hm,"Enum"),hm.forEach(a),ki=p(bp," for how to treat pre-existing downloads and data."),bp.forEach(a),ji=g(De),fa=r(De,"P",{});var on=d(fa);Ti=p(on,"The default mode is "),bo=r(on,"CODE",{});var $m=d(bo);Si=p($m,"REUSE_DATASET_IF_EXISTS"),$m.forEach(a),Ii=p(on,`, which will reuse both
raw downloads and the prepared dataset if they exist.`),on.forEach(a),Bi=g(De),vo=r(De,"P",{});var bm=d(vo);Ni=p(bm,"The generations modes:"),bm.forEach(a),Pi=g(De),ua=r(De,"TABLE",{});var rn=d(ua);wo=r(rn,"THEAD",{});var vm=d(wo);Be=r(vm,"TR",{});var ms=d(Be);Pr=r(ms,"TH",{}),d(Pr).forEach(a),Ci=g(ms),xo=r(ms,"TH",{});var wm=d(xo);Ri=p(wm,"Downloads"),wm.forEach(a),Li=g(ms),Do=r(ms,"TH",{});var xm=d(Do);Ai=p(xm,"Dataset"),xm.forEach(a),ms.forEach(a),vm.forEach(a),Oi=g(rn),Ne=r(rn,"TBODY",{});var gs=d(Ne);Pe=r(gs,"TR",{});var fs=d(Pe);za=r(fs,"TD",{});var vp=d(za);Eo=r(vp,"CODE",{});var Dm=d(Eo);qi=p(Dm,"REUSE_DATASET_IF_EXISTS"),Dm.forEach(a),Mi=p(vp," (default)"),vp.forEach(a),Vi=g(fs),yo=r(fs,"TD",{});var Em=d(yo);Ui=p(Em,"Reuse"),Em.forEach(a),zi=g(fs),ko=r(fs,"TD",{});var ym=d(ko);Fi=p(ym,"Reuse"),ym.forEach(a),fs.forEach(a),Gi=g(gs),Ce=r(gs,"TR",{});var us=d(Ce);jo=r(us,"TD",{});var km=d(jo);To=r(km,"CODE",{});var jm=d(To);Hi=p(jm,"REUSE_CACHE_IF_EXISTS"),jm.forEach(a),km.forEach(a),Wi=g(us),So=r(us,"TD",{});var Tm=d(So);Xi=p(Tm,"Reuse"),Tm.forEach(a),Ki=g(us),Io=r(us,"TD",{});var Sm=d(Io);Ji=p(Sm,"Fresh"),Sm.forEach(a),us.forEach(a),Yi=g(gs),Re=r(gs,"TR",{});var _s=d(Re);Bo=r(_s,"TD",{});var Im=d(Bo);No=r(Im,"CODE",{});var Bm=d(No);Qi=p(Bm,"FORCE_REDOWNLOAD"),Bm.forEach(a),Im.forEach(a),Zi=g(_s),Po=r(_s,"TD",{});var Nm=d(Po);ec=p(Nm,"Fresh"),Nm.forEach(a),tc=g(_s),Co=r(_s,"TD",{});var Pm=d(Co);ac=p(Pm,"Fresh"),Pm.forEach(a),_s.forEach(a),gs.forEach(a),rn.forEach(a),De.forEach(a),Cr=g(s),Le=r(s,"H2",{class:!0});var nn=d(Le);pt=r(nn,"A",{id:!0,class:!0,href:!0});var Cm=d(pt);Ro=r(Cm,"SPAN",{});var Rm=d(Ro);v(_a.$$.fragment,Rm),Rm.forEach(a),Cm.forEach(a),sc=g(nn),Lo=r(nn,"SPAN",{});var Lm=d(Lo);oc=p(Lm,"Splits"),Lm.forEach(a),nn.forEach(a),Rr=g(s),X=r(s,"DIV",{class:!0});var Tt=d(X);v(ha.$$.fragment,Tt),rc=g(Tt),Ao=r(Tt,"P",{});var Am=d(Ao);nc=p(Am,"Defines the split information for the generator."),Am.forEach(a),dc=g(Tt),Ae=r(Tt,"P",{});var hs=d(Ae);lc=p(hs,`This should be used as returned value of
`),Oo=r(hs,"CODE",{});var Om=d(Oo);ic=p(Om,"GeneratorBasedBuilder._split_generators"),Om.forEach(a),cc=p(hs,`.
See `),qo=r(hs,"CODE",{});var qm=d(qo);pc=p(qm,"GeneratorBasedBuilder._split_generators"),qm.forEach(a),mc=p(hs,` for more info and example
of usage.`),hs.forEach(a),gc=g(Tt),v(mt.$$.fragment,Tt),Tt.forEach(a),Lr=g(s),A=r(s,"DIV",{class:!0});var G=d(A);v($a.$$.fragment,G),fc=g(G),Fa=r(G,"P",{});var wp=d(Fa);Mo=r(wp,"CODE",{});var Mm=d(Mo);uc=p(Mm,"Enum"),Mm.forEach(a),_c=p(wp," for dataset splits."),wp.forEach(a),hc=g(G),Vo=r(G,"P",{});var Vm=d(Vo);$c=p(Vm,`Datasets are typically split into different subsets to be used at various
stages of training and evaluation.`),Vm.forEach(a),bc=g(G),oe=r(G,"UL",{});var St=d(oe);Ga=r(St,"LI",{});var xp=d(Ga);Uo=r(xp,"CODE",{});var Um=d(Uo);vc=p(Um,"TRAIN"),Um.forEach(a),wc=p(xp,": the training data."),xp.forEach(a),xc=g(St),Ha=r(St,"LI",{});var Dp=d(Ha);zo=r(Dp,"CODE",{});var zm=d(zo);Dc=p(zm,"VALIDATION"),zm.forEach(a),Ec=p(Dp,`: the validation data. If present, this is typically used as
evaluation data while iterating on a model (e.g. changing hyperparameters,
model architecture, etc.).`),Dp.forEach(a),yc=g(St),Wa=r(St,"LI",{});var Ep=d(Wa);Fo=r(Ep,"CODE",{});var Fm=d(Fo);kc=p(Fm,"TEST"),Fm.forEach(a),jc=p(Ep,`: the testing data. This is the data to report metrics on. Typically
you do not want to use this during model iteration as you may overfit to it.`),Ep.forEach(a),Tc=g(St),Xa=r(St,"LI",{});var yp=d(Xa);Go=r(yp,"CODE",{});var Gm=d(Go);Sc=p(Gm,"ALL"),Gm.forEach(a),Ic=p(yp,": the union of all defined dataset splits."),yp.forEach(a),St.forEach(a),Bc=g(G),ba=r(G,"P",{});var dn=d(ba);Nc=p(dn,"All splits, including compositions inherit from "),Ho=r(dn,"CODE",{});var Hm=d(Ho);Pc=p(Hm,"datasets.SplitBase"),Hm.forEach(a),Cc=p(dn,"."),dn.forEach(a),Rc=g(G),va=r(G,"P",{});var ln=d(va);Lc=p(ln,"See the "),Ka=r(ln,"A",{href:!0});var Wm=d(Ka);Ac=p(Wm,"guide"),Wm.forEach(a),Oc=p(ln," on splits for more information."),ln.forEach(a),qc=g(G),v(gt.$$.fragment,G),G.forEach(a),Ar=g(s),C=r(s,"DIV",{class:!0});var M=d(C);v(wa.$$.fragment,M),Mc=g(M),Wo=r(M,"P",{});var Xm=d(Wo);Vc=p(Xm,"Descriptor corresponding to a named split (train, test, \u2026)."),Xm.forEach(a),Uc=g(M),Xo=r(M,"P",{});var Km=d(Xo);zc=p(Km,"Example:"),Km.forEach(a),Fc=g(M),v(ft.$$.fragment,M),Gc=g(M),Ko=r(M,"P",{});var Jm=d(Ko);Hc=p(Jm,`The resulting split will correspond to 25% of the train split merged with
100% of the test split.`),Jm.forEach(a),Wc=g(M),v(ut.$$.fragment,M),Xc=g(M),v(_t.$$.fragment,M),Kc=g(M),v(ht.$$.fragment,M),M.forEach(a),Or=g(s),Oe=r(s,"DIV",{class:!0});var cn=d(Oe);v(xa.$$.fragment,cn),Jc=g(cn),Jo=r(cn,"P",{});var Ym=d(Jo);Yc=p(Ym,"Split corresponding to the union of all defined dataset splits."),Ym.forEach(a),cn.forEach(a),qr=g(s),z=r(s,"DIV",{class:!0});var Ee=d(z);v(Da.$$.fragment,Ee),Qc=g(Ee),Yo=r(Ee,"P",{});var Qm=d(Yo);Zc=p(Qm,"Reading instruction for a dataset."),Qm.forEach(a),ep=g(Ee),v($t.$$.fragment,Ee),tp=g(Ee),we=r(Ee,"DIV",{class:!0});var $s=d(we);v(Ea.$$.fragment,$s),ap=g($s),ya=r($s,"P",{});var pn=d(ya);sp=p(pn,"Creates a "),Qo=r(pn,"CODE",{});var Zm=d(Qo);op=p(Zm,"ReadInstruction"),Zm.forEach(a),rp=p(pn," instance out of a string spec."),pn.forEach(a),np=g($s),v(bt.$$.fragment,$s),$s.forEach(a),dp=g(Ee),xe=r(Ee,"DIV",{class:!0});var bs=d(xe);v(ka.$$.fragment,bs),lp=g(bs),Zo=r(bs,"P",{});var eg=d(Zo);ip=p(eg,"Translate instruction into a list of absolute instructions."),eg.forEach(a),cp=g(bs),er=r(bs,"P",{});var tg=d(er);pp=p(tg,"Those absolute instructions are then to be added together."),tg.forEach(a),bs.forEach(a),Ee.forEach(a),Mr=g(s),qe=r(s,"H2",{class:!0});var mn=d(qe);vt=r(mn,"A",{id:!0,class:!0,href:!0});var ag=d(vt);tr=r(ag,"SPAN",{});var sg=d(tr);v(ja.$$.fragment,sg),sg.forEach(a),ag.forEach(a),mp=g(mn),ar=r(mn,"SPAN",{});var og=d(ar);gp=p(og,"Version"),og.forEach(a),mn.forEach(a),Vr=g(s),re=r(s,"DIV",{class:!0});var vs=d(re);v(Ta.$$.fragment,vs),fp=g(vs),Sa=r(vs,"P",{});var gn=d(Sa);up=p(gn,"Dataset version "),sr=r(gn,"CODE",{});var rg=d(sr);_p=p(rg,"MAJOR.MINOR.PATCH"),rg.forEach(a),hp=p(gn,"."),gn.forEach(a),$p=g(vs),v(wt.$$.fragment,vs),vs.forEach(a),this.h()},h(){y(l,"name","hf:doc:metadata"),y(l,"content",JSON.stringify(Og)),y(n,"id","builder-classes"),y(n,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),y(n,"href","#builder-classes"),y(f,"class","relative group"),y(Ue,"id","datasets.DatasetBuilder"),y(Ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),y(Ue,"href","#datasets.DatasetBuilder"),y(K,"class","relative group"),y(Pa,"href","/docs/datasets/main/en/package_reference/builder_classes#datasets.DatasetBuilder"),y(Ca,"href","/docs/datasets/main/en/package_reference/builder_classes#datasets.BuilderConfig"),y(Oa,"href","/docs/datasets/main/en/package_reference/builder_classes#datasets.DatasetBuilder.download_and_prepare"),y(qa,"href","/docs/datasets/main/en/package_reference/builder_classes#datasets.DatasetBuilder.as_dataset"),y(Ma,"href","/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset"),y(Va,"href","/docs/datasets/main/en/package_reference/builder_classes#datasets.BuilderConfig"),y(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(Je,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(je,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(Qe,"id","datasets.DownloadManager"),y(Qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),y(Qe,"href","#datasets.DownloadManager"),y(Se,"class","relative group"),y(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(rt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y($e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(Ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(pt,"id","datasets.SplitGenerator"),y(pt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),y(pt,"href","#datasets.SplitGenerator"),y(Le,"class","relative group"),y(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(Ka,"href","./load_hub#splits"),y(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(Oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(we,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),y(vt,"id","datasets.Version"),y(vt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),y(vt,"href","#datasets.Version"),y(qe,"class","relative group"),y(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(s,h){e(document.head,l),$(s,_,h),$(s,f,h),e(f,n),e(n,u),w(t,u,null),e(f,i),e(f,de),e(de,R),$(s,H,h),$(s,K,h),e(K,Ue),e(Ue,ws),w(It,ws,null),e(K,fn),e(K,xs),e(xs,un),$(s,xr,h),$(s,le,h),e(le,_n),e(le,Pa),e(Pa,hn),e(le,$n),e(le,Ca),e(Ca,bn),e(le,vn),$(s,Dr,h),$(s,B,h),w(Bt,B,null),e(B,wn),e(B,Ds),e(Ds,xn),e(B,Dn),e(B,Ra),e(Ra,Es),e(Es,En),e(Ra,yn),e(B,kn),e(B,ye),e(ye,La),e(La,ys),e(ys,jn),e(La,Tn),e(ye,Sn),e(ye,Aa),e(Aa,Oa),e(Oa,In),e(Aa,Bn),e(ye,Nn),e(ye,ze),e(ze,qa),e(qa,Pn),e(ze,Cn),e(ze,Ma),e(Ma,Rn),e(ze,Ln),e(B,An),e(B,ae),e(ae,On),e(ae,ks),e(ks,qn),e(ae,Mn),e(ae,Va),e(Va,Vn),e(ae,Un),e(ae,js),e(js,zn),e(ae,Fn),e(B,Gn),e(B,ie),w(Nt,ie,null),e(ie,Hn),e(ie,Ts),e(Ts,Wn),e(ie,Xn),w(Fe,ie,null),e(B,Kn),e(B,O),w(Pt,O,null),e(O,Jn),e(O,Ss),e(Ss,Yn),e(O,Qn),e(O,Is),e(Is,Zn),e(O,ed),w(Ge,O,null),e(O,td),w(He,O,null),e(O,ad),w(We,O,null),e(B,sd),e(B,ce),w(Ct,ce,null),e(ce,od),e(ce,Bs),e(Bs,rd),e(ce,nd),w(Xe,ce,null),e(B,dd),e(B,pe),w(Rt,pe,null),e(pe,ld),e(pe,Lt),e(Lt,id),e(Lt,Ns),e(Ns,cd),e(Lt,pd),e(pe,md),w(Ke,pe,null),e(B,gd),e(B,Je),w(At,Je,null),e(Je,fd),e(Je,Ps),e(Ps,ud),$(s,Er,h),$(s,se,h),w(Ot,se,null),e(se,_d),e(se,Cs),e(Cs,hd),e(se,$d),e(se,me),e(me,Rs),e(Rs,bd),e(me,vd),e(me,Ls),e(Ls,wd),e(me,xd),e(me,As),e(As,Dd),e(me,Ed),$(s,yr,h),$(s,ke,h),w(qt,ke,null),e(ke,yd),e(ke,Os),e(Os,kd),$(s,kr,h),$(s,je,h),w(Mt,je,null),e(je,jd),e(je,qs),e(qs,Td),$(s,jr,h),$(s,W,h),w(Vt,W,null),e(W,Sd),e(W,Ut),e(Ut,Id),e(Ut,Ms),e(Ms,Bd),e(Ut,Nd),e(W,Pd),e(W,Ye),e(Ye,Vs),e(Vs,Cd),e(Ye,Rd),e(Ye,Us),e(Us,Ld),e(Ye,Ad),e(W,Od),e(W,J),w(zt,J,null),e(J,qd),e(J,zs),e(zs,Md),e(J,Vd),e(J,Te),e(Te,Fs),e(Fs,Ud),e(Te,zd),e(Te,Gs),e(Gs,Fd),e(Te,Gd),e(Te,Hs),e(Hs,Hd),e(J,Wd),e(J,Ws),e(Ws,Xd),$(s,Tr,h),$(s,Se,h),e(Se,Qe),e(Qe,Xs),w(Ft,Xs,null),e(Se,Kd),e(Se,Ks),e(Ks,Jd),$(s,Sr,h),$(s,P,h),w(Gt,P,null),e(P,Yd),e(P,Y),w(Ht,Y,null),e(Y,Qd),e(Y,Js),e(Js,Zd),e(Y,el),e(Y,Wt),e(Wt,tl),e(Wt,Ys),e(Ys,al),e(Wt,sl),e(Y,ol),w(Ze,Y,null),e(P,rl),e(P,ge),w(Xt,ge,null),e(ge,nl),e(ge,Kt),e(Kt,dl),e(Kt,Qs),e(Qs,ll),e(Kt,il),e(ge,cl),w(et,ge,null),e(P,pl),e(P,fe),w(Jt,fe,null),e(fe,ml),e(fe,Yt),e(Yt,gl),e(Yt,Zs),e(Zs,fl),e(Yt,ul),e(fe,_l),w(tt,fe,null),e(P,hl),e(P,ue),w(Qt,ue,null),e(ue,$l),e(ue,eo),e(eo,bl),e(ue,vl),w(at,ue,null),e(P,wl),e(P,_e),w(Zt,_e,null),e(_e,xl),e(_e,to),e(to,Dl),e(_e,El),w(st,_e,null),e(P,yl),e(P,he),w(ea,he,null),e(he,kl),e(he,ao),e(ao,jl),e(he,Tl),w(ot,he,null),e(P,Sl),e(P,rt),w(ta,rt,null),e(rt,Il),e(rt,so),e(so,Bl),$(s,Ir,h),$(s,L,h),w(aa,L,null),e(L,Nl),e(L,V),e(V,Pl),e(V,oo),e(oo,Cl),e(V,Rl),e(V,ro),e(ro,Ll),e(V,Al),e(V,no),e(no,Ol),e(V,ql),e(V,lo),e(lo,Ml),e(V,Vl),e(V,io),e(io,Ul),e(V,zl),e(L,Fl),e(L,$e),w(sa,$e,null),e($e,Gl),e($e,oa),e(oa,Hl),e(oa,co),e(co,Wl),e(oa,Xl),e($e,Kl),w(nt,$e,null),e(L,Jl),e(L,Q),w(ra,Q,null),e(Q,Yl),e(Q,na),e(na,Ql),e(na,po),e(po,Zl),e(na,ei),e(Q,ti),e(Q,da),e(da,ai),e(da,mo),e(mo,si),e(da,oi),e(Q,ri),w(dt,Q,null),e(L,ni),e(L,Z),w(la,Z,null),e(Z,di),e(Z,go),e(go,li),e(Z,ii),e(Z,ia),e(ia,ci),e(ia,fo),e(fo,pi),e(ia,mi),e(Z,gi),w(lt,Z,null),e(L,fi),e(L,be),w(ca,be,null),e(be,ui),e(be,uo),e(uo,_i),e(be,hi),w(it,be,null),e(L,$i),e(L,ve),w(pa,ve,null),e(ve,bi),e(ve,_o),e(_o,vi),e(ve,wi),w(ct,ve,null),$(s,Br,h),$(s,Ie,h),w(ma,Ie,null),e(Ie,xi),e(Ie,ho),e(ho,Di),$(s,Nr,h),$(s,U,h),w(ga,U,null),e(U,Ei),e(U,Ua),e(Ua,$o),e($o,yi),e(Ua,ki),e(U,ji),e(U,fa),e(fa,Ti),e(fa,bo),e(bo,Si),e(fa,Ii),e(U,Bi),e(U,vo),e(vo,Ni),e(U,Pi),e(U,ua),e(ua,wo),e(wo,Be),e(Be,Pr),e(Be,Ci),e(Be,xo),e(xo,Ri),e(Be,Li),e(Be,Do),e(Do,Ai),e(ua,Oi),e(ua,Ne),e(Ne,Pe),e(Pe,za),e(za,Eo),e(Eo,qi),e(za,Mi),e(Pe,Vi),e(Pe,yo),e(yo,Ui),e(Pe,zi),e(Pe,ko),e(ko,Fi),e(Ne,Gi),e(Ne,Ce),e(Ce,jo),e(jo,To),e(To,Hi),e(Ce,Wi),e(Ce,So),e(So,Xi),e(Ce,Ki),e(Ce,Io),e(Io,Ji),e(Ne,Yi),e(Ne,Re),e(Re,Bo),e(Bo,No),e(No,Qi),e(Re,Zi),e(Re,Po),e(Po,ec),e(Re,tc),e(Re,Co),e(Co,ac),$(s,Cr,h),$(s,Le,h),e(Le,pt),e(pt,Ro),w(_a,Ro,null),e(Le,sc),e(Le,Lo),e(Lo,oc),$(s,Rr,h),$(s,X,h),w(ha,X,null),e(X,rc),e(X,Ao),e(Ao,nc),e(X,dc),e(X,Ae),e(Ae,lc),e(Ae,Oo),e(Oo,ic),e(Ae,cc),e(Ae,qo),e(qo,pc),e(Ae,mc),e(X,gc),w(mt,X,null),$(s,Lr,h),$(s,A,h),w($a,A,null),e(A,fc),e(A,Fa),e(Fa,Mo),e(Mo,uc),e(Fa,_c),e(A,hc),e(A,Vo),e(Vo,$c),e(A,bc),e(A,oe),e(oe,Ga),e(Ga,Uo),e(Uo,vc),e(Ga,wc),e(oe,xc),e(oe,Ha),e(Ha,zo),e(zo,Dc),e(Ha,Ec),e(oe,yc),e(oe,Wa),e(Wa,Fo),e(Fo,kc),e(Wa,jc),e(oe,Tc),e(oe,Xa),e(Xa,Go),e(Go,Sc),e(Xa,Ic),e(A,Bc),e(A,ba),e(ba,Nc),e(ba,Ho),e(Ho,Pc),e(ba,Cc),e(A,Rc),e(A,va),e(va,Lc),e(va,Ka),e(Ka,Ac),e(va,Oc),e(A,qc),w(gt,A,null),$(s,Ar,h),$(s,C,h),w(wa,C,null),e(C,Mc),e(C,Wo),e(Wo,Vc),e(C,Uc),e(C,Xo),e(Xo,zc),e(C,Fc),w(ft,C,null),e(C,Gc),e(C,Ko),e(Ko,Hc),e(C,Wc),w(ut,C,null),e(C,Xc),w(_t,C,null),e(C,Kc),w(ht,C,null),$(s,Or,h),$(s,Oe,h),w(xa,Oe,null),e(Oe,Jc),e(Oe,Jo),e(Jo,Yc),$(s,qr,h),$(s,z,h),w(Da,z,null),e(z,Qc),e(z,Yo),e(Yo,Zc),e(z,ep),w($t,z,null),e(z,tp),e(z,we),w(Ea,we,null),e(we,ap),e(we,ya),e(ya,sp),e(ya,Qo),e(Qo,op),e(ya,rp),e(we,np),w(bt,we,null),e(z,dp),e(z,xe),w(ka,xe,null),e(xe,lp),e(xe,Zo),e(Zo,ip),e(xe,cp),e(xe,er),e(er,pp),$(s,Mr,h),$(s,qe,h),e(qe,vt),e(vt,tr),w(ja,tr,null),e(qe,mp),e(qe,ar),e(ar,gp),$(s,Vr,h),$(s,re,h),w(Ta,re,null),e(re,fp),e(re,Sa),e(Sa,up),e(Sa,sr),e(sr,_p),e(Sa,hp),e(re,$p),w(wt,re,null),Ur=!0},p(s,[h]){const Ia={};h&2&&(Ia.$$scope={dirty:h,ctx:s}),Fe.$set(Ia);const or={};h&2&&(or.$$scope={dirty:h,ctx:s}),Ge.$set(or);const rr={};h&2&&(rr.$$scope={dirty:h,ctx:s}),He.$set(rr);const nr={};h&2&&(nr.$$scope={dirty:h,ctx:s}),We.$set(nr);const Ba={};h&2&&(Ba.$$scope={dirty:h,ctx:s}),Xe.$set(Ba);const dr={};h&2&&(dr.$$scope={dirty:h,ctx:s}),Ke.$set(dr);const lr={};h&2&&(lr.$$scope={dirty:h,ctx:s}),Ze.$set(lr);const ir={};h&2&&(ir.$$scope={dirty:h,ctx:s}),et.$set(ir);const Me={};h&2&&(Me.$$scope={dirty:h,ctx:s}),tt.$set(Me);const cr={};h&2&&(cr.$$scope={dirty:h,ctx:s}),at.$set(cr);const pr={};h&2&&(pr.$$scope={dirty:h,ctx:s}),st.$set(pr);const N={};h&2&&(N.$$scope={dirty:h,ctx:s}),ot.$set(N);const mr={};h&2&&(mr.$$scope={dirty:h,ctx:s}),nt.$set(mr);const Ja={};h&2&&(Ja.$$scope={dirty:h,ctx:s}),dt.$set(Ja);const gr={};h&2&&(gr.$$scope={dirty:h,ctx:s}),lt.$set(gr);const Ve={};h&2&&(Ve.$$scope={dirty:h,ctx:s}),it.$set(Ve);const Ya={};h&2&&(Ya.$$scope={dirty:h,ctx:s}),ct.$set(Ya);const fr={};h&2&&(fr.$$scope={dirty:h,ctx:s}),mt.$set(fr);const Qa={};h&2&&(Qa.$$scope={dirty:h,ctx:s}),gt.$set(Qa);const ur={};h&2&&(ur.$$scope={dirty:h,ctx:s}),ft.$set(ur);const xt={};h&2&&(xt.$$scope={dirty:h,ctx:s}),ut.$set(xt);const _r={};h&2&&(_r.$$scope={dirty:h,ctx:s}),_t.$set(_r);const hr={};h&2&&(hr.$$scope={dirty:h,ctx:s}),ht.$set(hr);const ne={};h&2&&(ne.$$scope={dirty:h,ctx:s}),$t.$set(ne);const $r={};h&2&&($r.$$scope={dirty:h,ctx:s}),bt.$set($r);const br={};h&2&&(br.$$scope={dirty:h,ctx:s}),wt.$set(br)},i(s){Ur||(x(t.$$.fragment,s),x(It.$$.fragment,s),x(Bt.$$.fragment,s),x(Nt.$$.fragment,s),x(Fe.$$.fragment,s),x(Pt.$$.fragment,s),x(Ge.$$.fragment,s),x(He.$$.fragment,s),x(We.$$.fragment,s),x(Ct.$$.fragment,s),x(Xe.$$.fragment,s),x(Rt.$$.fragment,s),x(Ke.$$.fragment,s),x(At.$$.fragment,s),x(Ot.$$.fragment,s),x(qt.$$.fragment,s),x(Mt.$$.fragment,s),x(Vt.$$.fragment,s),x(zt.$$.fragment,s),x(Ft.$$.fragment,s),x(Gt.$$.fragment,s),x(Ht.$$.fragment,s),x(Ze.$$.fragment,s),x(Xt.$$.fragment,s),x(et.$$.fragment,s),x(Jt.$$.fragment,s),x(tt.$$.fragment,s),x(Qt.$$.fragment,s),x(at.$$.fragment,s),x(Zt.$$.fragment,s),x(st.$$.fragment,s),x(ea.$$.fragment,s),x(ot.$$.fragment,s),x(ta.$$.fragment,s),x(aa.$$.fragment,s),x(sa.$$.fragment,s),x(nt.$$.fragment,s),x(ra.$$.fragment,s),x(dt.$$.fragment,s),x(la.$$.fragment,s),x(lt.$$.fragment,s),x(ca.$$.fragment,s),x(it.$$.fragment,s),x(pa.$$.fragment,s),x(ct.$$.fragment,s),x(ma.$$.fragment,s),x(ga.$$.fragment,s),x(_a.$$.fragment,s),x(ha.$$.fragment,s),x(mt.$$.fragment,s),x($a.$$.fragment,s),x(gt.$$.fragment,s),x(wa.$$.fragment,s),x(ft.$$.fragment,s),x(ut.$$.fragment,s),x(_t.$$.fragment,s),x(ht.$$.fragment,s),x(xa.$$.fragment,s),x(Da.$$.fragment,s),x($t.$$.fragment,s),x(Ea.$$.fragment,s),x(bt.$$.fragment,s),x(ka.$$.fragment,s),x(ja.$$.fragment,s),x(Ta.$$.fragment,s),x(wt.$$.fragment,s),Ur=!0)},o(s){D(t.$$.fragment,s),D(It.$$.fragment,s),D(Bt.$$.fragment,s),D(Nt.$$.fragment,s),D(Fe.$$.fragment,s),D(Pt.$$.fragment,s),D(Ge.$$.fragment,s),D(He.$$.fragment,s),D(We.$$.fragment,s),D(Ct.$$.fragment,s),D(Xe.$$.fragment,s),D(Rt.$$.fragment,s),D(Ke.$$.fragment,s),D(At.$$.fragment,s),D(Ot.$$.fragment,s),D(qt.$$.fragment,s),D(Mt.$$.fragment,s),D(Vt.$$.fragment,s),D(zt.$$.fragment,s),D(Ft.$$.fragment,s),D(Gt.$$.fragment,s),D(Ht.$$.fragment,s),D(Ze.$$.fragment,s),D(Xt.$$.fragment,s),D(et.$$.fragment,s),D(Jt.$$.fragment,s),D(tt.$$.fragment,s),D(Qt.$$.fragment,s),D(at.$$.fragment,s),D(Zt.$$.fragment,s),D(st.$$.fragment,s),D(ea.$$.fragment,s),D(ot.$$.fragment,s),D(ta.$$.fragment,s),D(aa.$$.fragment,s),D(sa.$$.fragment,s),D(nt.$$.fragment,s),D(ra.$$.fragment,s),D(dt.$$.fragment,s),D(la.$$.fragment,s),D(lt.$$.fragment,s),D(ca.$$.fragment,s),D(it.$$.fragment,s),D(pa.$$.fragment,s),D(ct.$$.fragment,s),D(ma.$$.fragment,s),D(ga.$$.fragment,s),D(_a.$$.fragment,s),D(ha.$$.fragment,s),D(mt.$$.fragment,s),D($a.$$.fragment,s),D(gt.$$.fragment,s),D(wa.$$.fragment,s),D(ft.$$.fragment,s),D(ut.$$.fragment,s),D(_t.$$.fragment,s),D(ht.$$.fragment,s),D(xa.$$.fragment,s),D(Da.$$.fragment,s),D($t.$$.fragment,s),D(Ea.$$.fragment,s),D(bt.$$.fragment,s),D(ka.$$.fragment,s),D(ja.$$.fragment,s),D(Ta.$$.fragment,s),D(wt.$$.fragment,s),Ur=!1},d(s){a(l),s&&a(_),s&&a(f),E(t),s&&a(H),s&&a(K),E(It),s&&a(xr),s&&a(le),s&&a(Dr),s&&a(B),E(Bt),E(Nt),E(Fe),E(Pt),E(Ge),E(He),E(We),E(Ct),E(Xe),E(Rt),E(Ke),E(At),s&&a(Er),s&&a(se),E(Ot),s&&a(yr),s&&a(ke),E(qt),s&&a(kr),s&&a(je),E(Mt),s&&a(jr),s&&a(W),E(Vt),E(zt),s&&a(Tr),s&&a(Se),E(Ft),s&&a(Sr),s&&a(P),E(Gt),E(Ht),E(Ze),E(Xt),E(et),E(Jt),E(tt),E(Qt),E(at),E(Zt),E(st),E(ea),E(ot),E(ta),s&&a(Ir),s&&a(L),E(aa),E(sa),E(nt),E(ra),E(dt),E(la),E(lt),E(ca),E(it),E(pa),E(ct),s&&a(Br),s&&a(Ie),E(ma),s&&a(Nr),s&&a(U),E(ga),s&&a(Cr),s&&a(Le),E(_a),s&&a(Rr),s&&a(X),E(ha),E(mt),s&&a(Lr),s&&a(A),E($a),E(gt),s&&a(Ar),s&&a(C),E(wa),E(ft),E(ut),E(_t),E(ht),s&&a(Or),s&&a(Oe),E(xa),s&&a(qr),s&&a(z),E(Da),E($t),E(Ea),E(bt),E(ka),s&&a(Mr),s&&a(qe),E(ja),s&&a(Vr),s&&a(re),E(Ta),E(wt)}}}const Og={local:"builder-classes",sections:[{local:"datasets.DatasetBuilder",title:"Builders"},{local:"datasets.DownloadManager",title:"Download"},{local:"datasets.SplitGenerator",title:"Splits"},{local:"datasets.Version",title:"Version"}],title:"Builder classes"};function qg(k){return cg(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Gg extends ng{constructor(l){super();dg(this,l,qg,Ag,lg,{})}}export{Gg as default,Og as metadata};
